/**
 * 阅读记录（打开过书页的记录）
 * 这个记录会一直保存，清理缓存时，不删除
 */
var Track = {};
Track.SIZE = 100; // 最多记录
Track.ID = "track.id.coll";
Track.INFO = "track.info.";
Track.RECORD = "track.record.";

/**
 * 数据写入
 * record JSON 对象
 */
Track.putData = function(bid, data, type) {
    if (!bid) return false;

    var type = type || "INFO";
    dataStorage.setItem(Track[type] + bid, JSON.stringify(data));

    // 更新阅读记录时，需要相应的调整位置
    if (type == "RECORD") {
        var sortData = dataStorage.getItem(Track.ID);
        if (sortData) {
            sortData = JSON.parse(sortData);

            bid = parseInt(bid);
            var index = sortData.indexOf(bid);
            if (index > -1) {
                sortData.splice(index, 1);
            }
            // 将书号写到最前面
            sortData.unshift(bid);
            dataStorage.setItem(Track.ID, JSON.stringify(sortData));
        } else {
            dataStorage.setItem(Track.ID, JSON.stringify([bid]));
        }
    }
};

// 读取阅读记录单条
Track.getData = function(bid, type) {
    if (!bid) return false;

    var type = type || "INFO";
    var data = dataStorage.getItem(Track[type] + bid);
    if (data) {
        try {
            data = JSON.parse(data);
        } catch(e) {}
    }
    return data;
};

// 删除阅读记录
Track.removeData = function(bid) {
    if (!bid) return false;

    dataStorage.removeItem("track.info."+bid);
    dataStorage.removeItem("track.record."+bid);
    // 处理记录
    var sortData = dataStorage.getItem(Track.ID);
    if (sortData) {
        try {
            sortData = JSON.parse(sortData);

            bid = parseInt(bid);
            var index = sortData.indexOf(bid);
            if (index > -1) {
                sortData.splice(index, 1);
            }
            dataStorage.setItem(Track.ID, JSON.stringify(sortData));
        } catch(e) {}
    }
};

// 读取全部
Track.getAll = function(type) {
    var prefix = type == 'RECORD' ? 'track.record.' : 'track.info.';
    var data = [];
    
    var sortData = dataStorage.getItem(Track.ID);
    if (sortData) {
        try {
            sortData = JSON.parse(sortData);
            // 查出作品数据
            for (var id in sortData) {
                data.push(dataStorage.getItem(prefix + sortData[id]));
            }
        } catch(e) {}
    }
    return data;
};

// 清空阅读记录
Track.clearAll = function() {
    clearStorageData("track");
};
