/**
 * 作品相关的信息
 */
(function() {
    
    var bid = 0;
    var btitle = "";
    var record;

    var myScroll;
    function myScrollLoaded() {
        myScroll = new mScroll("wrapper", {
            hScroll: false
        });
    }
    
    $(document).bind("touchmove", function (e) { e.preventDefault(); }, false);
    $(document).bind("DOMContentLoaded", function() {        
        myScrollLoaded();

        bid = parseInt(dataStorage.getItem("read.bid"));
        if (!bid) {
            showMsg("作品信息不存在");
            setTimeout(function() {
                go("shelf.html");
            }, 1000);
        }
        
        var btype = dataStorage.getItem("read.btype");
        if (btype == 'down') {
            showDownIntro();
        } else {
            showLocalIntro();
        }

    }, false);

    $("#main").bind(CLICK_EVENT, function(e) {
        e.preventDefault();
        onTouchEvent(e);
    });

    // 打开本地文件
    function showDownIntro() {
        var bookinfo_data = bookAPI.getBookInfo(bid);
        if (!bookinfo_data) {
            showMsg("作品信息不存在");   
            return false;
        }

        try {
            bookinfo_data = JSON.parse(bookinfo_data);
            var bookinfo = eval("("+bookinfo_data.info+")"), dir = bookinfo_data.dir;            
            delete bookinfo_data;

            fetchHtml(bookinfo, "down", dir);
        } catch (e) {}
    }

    // 打开作品介绍页面
    function showLocalIntro() {
        // 载入数据
        var url = "book/"+bid+"/book.json";
        $.jsonp(url, function(ret) {
            // 判断是否有数据
            if (!ret) {
                showMsg("作品信息不存在");
                return false;
            }

            fetchHtml(ret, "local");
            
        }, 'bookdata');
    }

    function fetchHtml(data, btype, dir) {
        btitle = data.bookname;
        dataStorage.setItem("read.btitle", data.bookname);        
            
        var readbtn_txt = '开始阅读';
        record = Track.getData(bid, "RECORD");
        if (record) readbtn_txt = '继续阅读';

        // 写入最近阅读记录
        var record_info = {"bid": bid, "btitle": data.bookname, "penname": data.penname};
        Track.putData(bid, record_info);

        var bookinfo = $("#bookinfo");
        // 封面
        var img = 'book/'+bid+'/cover.png';
        if (btype == "down") {
            img = dir + '/'+bid+'/cover.png';
        }

        // 如果已经有缓存章节列表，就不保存了
        var check_chapter_iscache = dataStorage.getItem("book.chapter."+bid);
        if (!check_chapter_iscache) {
            // 缓存章节列表
            dataStorage.setItem("book.chapter."+bid, JSON.stringify(data.articles));
            // 章节数量
            dataStorage.setItem("book.chapter_total."+bid, data.articles.length);
        } else {
            // 检查当前作品，章节列表是否有更新，如果有更新就自动下载新的章节列表
            cacheChapterDir(bid, data.articles.length);
        }

        // 作品写作进度
        var progress_icon = '';
        if (data.progress) {
            if (data.progress == 5) {
                progress_icon = '<em class="end"></em>';                
            } else {
                progress_icon = '<em class="in"></em>';
            }
        }

        var pic_html = '<div class="book-cover"><img src="'+img+'" id="book_cover_img">';
        if (progress_icon) {
            pic_html += progress_icon;
        }
        pic_html += '<span class="shadow"></span></div>';

        var div = document.createElement("div");
        div.setClass("pic").html(pic_html);
        bookinfo.insertChild(div);
        
        // 封面错误时，载入默认的封面
        $("#book_cover_img").bind("error", function() {
            this.attr({"src": "img/default_middle_cover.png"});
        });
        
        // 章节价，如果没有设置就是3个币
        var article_sell_coin = data.price_base || 3;
        var copyright = data.copyright || '陌上香坊';

        // 内容
        var txt = '<p class="title">'+data.bookname+'</p>';
            txt += '<p>作者：'+data.penname+'</p>';
            if (data.progress && data.progress == 5) {
                txt += '<p>状态：已完结</p>';
            } else {
                txt += '<p>状态：连载中</p>';
            }
            txt += '<p>字数：'+data.words+'</p>';
            txt += '<p>价格：'+article_sell_coin+' 陌上币/千字</p>';
        //if (data.price_offline > 0) txt += '<p>全本：'+data.price_offline+' 陌上币/本</p>';
            txt += '<p>版权：'+copyright+'</p>';

        var div = document.createElement("div");
        div.setClass("txt").html(txt);
        bookinfo.insertChild(div);

        // btn
        var btn_txt = '<span data-type="read" data-id="1" class="btn_color_green">'+readbtn_txt+'</span>';
            btn_txt += '&nbsp;&nbsp;&nbsp;&nbsp;<span class="btn_color_blue2" data-type="gopay">前去充值</span>';
            btn_txt += '&nbsp;&nbsp;&nbsp;&nbsp;<span class="btn_color_blue" data-type="downzip">全本下载</span>';

        var div = document.createElement("div");
        div.setClass("ac_btn").html(btn_txt);
        bookinfo.insertChild(div);

        // 显示简介内容
        $("#intro_show").html(data.intro.replace(/\n/g, "<br>"));
        
        // 显示章节列表
        var doc = document, ul, li;
        ul = doc.createElement("ul");
        
        // 章节数量
        var chapter_total = dataStorage.getItem("book.chapter_total."+bid);
        if (!chapter_total) chapter_total = data.articles.length;

        var total_html = '<span class="free" data-type="articles">进入目录</span>共 '+chapter_total+' 章';

        li = doc.createElement("li");
        li.html(total_html);
        ul.insertChild(li);
        
        var limit = 10; // 列表显示条数
        
        var article, article_type;
        for (var i = 0; i < data.articles.length; i++) {
            if (i >= limit) break;

            article = data.articles[i];
            article_type = article.vip == 1 ? '<span class="vip">付费</span>' : '<span class="free">免费</span>';
            
            li = doc.createElement("li");
            li.attr({"data-type": "sread", "data-id": article.index}).html(article_type+article.title);
            ul.insertChild(li);
        }

        // 更多章节
        if (data.articles.length > limit) {
            li = doc.createElement("li");
            li.attr({"data-type": "articles", "class": "btn_more"}).html('<span data-type="articles" class="btn_default">查看更多章节</span>');
            ul.insertChild(li);
        }
        $("#articles_show").insertChild(ul);
        myScroll.refresh();        
        
        delete data;        
    }

    // 处理当前页面的点击事件
    function onTouchEvent(touch) {
        if (!touch) return false;
        var target = touch.target;

        // 要先判断事件类型
        var type = target.attr("data-type");
        
        if (type == "read") { // 去阅读页
            var id = target.attr("data-id");
            if (!id && id == '') return false;
            
            var aindex = id, page = 1;
            if (record) {
                aindex = record["aindex"];
                page = record["page"];
            }
            openRead(bid, aindex, page);

        } else if (type == "sread") { // 点章节阅读
            var id = target.attr("data-id");
            if (!id && id == '') return false;
            openRead(bid, id, 1);
        } else if (type == "articles") { // 去章节列表
            aindex = parseInt(nlg(dataStorage.getItem("read.aindex"), 1));
            openDir(aindex);
        } else if (type == "gopay") {
            openPay(bid);
        } else if (type == "downzip") { // 下载zip
            if (msxfAPI.onLine() == false) {
                showMsg("网络不给力，请开启网络重试");
                return false;
            }
            // 显示下载面板
            showDown();
        }
    }

    // 显示下载选项
    function showDown() {
        var iw = window.innerWidth;
        var ih = window.innerHeight;

        var doc = document, ul, li;

        var wrapObj = $("#comm_book_down_wrap");
        var dialogObj = $("#comm_book_down");

        // 检查对话框是不是已经创建出来过了，因为$方法总是返回一个对象
        if (wrapObj.id && dialogObj.id) return;

        // 背景
        var wrap = doc.createElement("div");
        wrap.css({"position": "absolute", "zIndex": "5555", "visibility": "visible", "backgroundColor": "#908E8F", "opacity": 0.45, "top": 0, "left": 0, "width": iw, "height": ih});
        wrap.attr({"id": "comm_book_down_wrap"});
        $("body").insertChild(wrap);

        // 显示确认框
        var dialog = doc.createElement("div");
        dialog.setClass("comm_book_down").attr({"id": "comm_book_down"});

        // title
        var dialog_title = doc.createElement("div");
        dialog_title.setClass("comm_dialog_title").html('下载作品<span class="close" data-id="close"></span>');
        dialog.insertChild(dialog_title);

        // 提示
        var dialog_body = doc.createElement("div");
        dialog_body.setClass("info");
        dialog.insertChild(dialog_body);

        ul = doc.createElement("ul");
        dialog_body.insertChild(ul);

        li = doc.createElement("li");
        li.html('<p>当前作品已经在书架了！根据自己需要选择要下载的章节；Wifi网络建议直接下载全本！下载过的章节阅读时可不需要联网！对于要付费的章节，建议直接快速订阅！</p>');
        ul.insertChild(li);

        var btn_html = '<span data-id="btn-down" data-value="all" class="btn_color_green">下载全本</span>&nbsp;&nbsp;<span data-id="btn-down" data-value="free" class="btn_color_blue">下载免费</span>&nbsp;&nbsp;';
            btn_html += '<span data-id="btn-down" data-value="buyfull" class="btn_color_blue2">快速订阅</span>';

        li = doc.createElement("li");
        li.setClass("btn").html(btn_html);
        ul.insertChild(li);

        // tips
        var tips_html = '<p><font color="color_red">*</font> 全本下载：包括VIP章节也一并下载；下载免费：表示仅下载免费章节；</p>';
            tips_html += '<p><font color="color_red">*</font> 快速订阅：表示一次性支付当前已发布章节需要的费用！</p>';

        // tips
        var dialog_tips = doc.createElement("div");
        dialog_tips.setClass("tips").html(tips_html);
        dialog.insertChild(dialog_tips);

        $("body").insertChild(dialog);

        dialog.bind(START_EVENT, function(e) {
            e.preventDefault();

            var target = e.target;

            if (target != null) {
                var id = target.attr("data-id");
                if (!id) return false;
                if (id == "btn-down") {
                    var type = target.attr("data-value");
                    switch (type) {
                        case 'free': // 免费
                            downBook(bid, btitle, 'zip', 'free');
                            break;
                        case 'buyfull': // 购买全本
                            buyFull();
                            break;
                        default: // 全本
                            downBook(bid, btitle, 'zip');
                            break;
                    }
                    dialog.remove();
                    wrap.remove();
                } else if (id == "close") {
                    dialog.remove();
                    wrap.remove();
                }
            }
        });

        dialog.bind(MOVE_EVENT, function(e) { 
            e.preventDefault();
        });
        dialog.bind(END_EVENT, function(e) {
            e.preventDefault();
        });

        // 返回
        wrap.bind(START_EVENT, function(e) {
            e.preventDefault();
            dialog.remove();
            wrap.remove();
        });
    }

    // 全本购买
    function buyFull() {

        if (msxfAPI.onLine() == false) {
            showMsg("网络不给力，请开启网络重试");
            return false;
        }

        // 判断是否登陆
        if (!SID()) {
            showLoginDialog();
            return false;
        }

        // 直接的全本购买，默认值参数
        var aid = aindex = 1;

        // 开始loading
        $.loading().init();
        $.loading().open();
        
        var is_complete = false;
        // 最多15秒，关闭进度条
        setTimeout(function() {
            $.loading().close();
            if (!is_complete) {
                showMsg("网络不畅操作失败，请重试");
            }
        }, 20000);

        // 提交
        var mobileUniqid = msxfAPI.mobileUniqid();
        var url = server('apk') + "/article/buy?bid="+bid+"&aid="+aid+"&ac=buy&fastbuy=1&sessid="+SID()+"&buymode=full&uniqid="+mobileUniqid+"&safe="+SAFE_CODE();
        $.jsonp(url, function(ret) {
            // 操作完成
            is_complete = true;
            $.loading().close();
            if (!ret) {
                showMsg("章节订阅失败，请重试");
                return false;
            }

            if (ret.errno != 0) {
                $.loading().close();
                // 要先登陆
                if (ret.errno == -2) {
                    showLoginDialog();
                    return false;                
                }
                
                // 余额不足，进入充值
                if (ret.errno == -10) {
                    showMsg(ret.msg);
                    // 2秒之后，进入充值频道
                    setTimeout(function() {
                        openPay(bid);
                    }, 2000);
                    return false;
                }
                showMsg(ret.msg);
                return false;
            }

            // 继续阅读
            if (ret.isbuy == 1) {
                // 购买成功 要在APP里面，设置购买记录
                msxfAPI.saveBuyRecord(bid, parseInt(aid), "full");
                setTimeout(function() {
                    openRead(bid, aindex);
                }, 500);
            } else {
                showMsg("全本订阅失败，请重试");
                return false;
            }
        }, 'xhr');
    }

})();
