/**
 * 显示最近阅读
 */
(function() {

    var POS_DATA_ID = "history.pos";
    var myScroll;

    var nodata_html = '<p>暂无阅读记录</p>';
    nodata_html += '<p>大神！去书城找点书看吧！</p>';
    nodata_html += '<p>炫色书城有大量精彩作品，包括女生言情、男生幻侠、青春校园等各类作品；并且支持全本下载后离线阅读！</p>';
    nodata_html += '<p class="go_btn"><span class="btn_color_green" data-type="go-store">进入书城</span></p>';

    function myScrollLoaded() {
        myScroll = new mScroll("wrapper", {
            hScroll: false,
            onScrollEnd: function() {
                // 记录这次坐标
                try {
                    currentPosData(POS_DATA_ID, this.y);
                } catch (e) {}
            }
        });
    }

    $(document).bind("touchmove", function (e) { e.preventDefault(); }, false);
    $(document).bind("DOMContentLoaded", function() { 
        myScrollLoaded();
        loadData();        

    }, false);

    $("#main").bind(CLICK_EVENT, function(e) {
        e.preventDefault();
        onTouchEvent(e);
    });

    // 显示最近阅读
    function loadData() {
        var tracks = Track.getAll();
        var bookdata = $("#bookdata");
        bookdata.empty();

        var doc = document, book, record, dl, dt, dd, record_html = '';
        for (var i = 0; i < tracks.length; i++) {
            if (!tracks[i]) continue;
            book = JSON.parse(tracks[i]);
            if (!book) continue;

            dl = doc.createElement("dl");
            dl.setClass("item").attr({"data-bid": book["bid"], "data-btitle":  book["btitle"]});
            
            dt = doc.createElement("dt");
            dt.html(fetchBookCoverCode(book["bid"], "middle"));
            dl.appendChild(dt);

            record_html = '<p class="title">'+book["btitle"]+'</p><p>'+book["penname"]+'</p>';
            // 读取阅读记录
            record = Track.getData(book["bid"], "RECORD");
            if (record) {
                record_html += '<p>已阅读：'+record["percent"]+'</p>';
            }

            dd = doc.createElement("dd");
            dd.html(record_html);                    
            dl.appendChild(dd);
            
            bookdata.appendChild(dl);
        }
        // 如果有数据，里面要加一个清空的按钮
        if (tracks.length > 0) {
            $("#cleardata").css({"visibility": "visible"});
        } else {
            var div = doc.createElement("div");
            div.attr({"id": "nodata"}).html(nodata_html);
            bookdata.insertChild(div);
        }
        myScroll.refresh();

        try {
            var pos_y = currentPosData(POS_DATA_ID);
            if (pos_y) {
                setTimeout(function() {
                    myScroll.scrollTo(0, pos_y, 0);
                }, 10);
            }
        } catch (e) {}
    }

    // 页面事件
    function onTouchEvent(e) {
        if (!e) return false;

        var target = e.target;

        var type = target.attr("data-type");
        if (type == "clear") {
            var conf = {"msg": "确定要清空所有的阅读记录吗？", "yestxt": "确定清空"};
            var yesBtn = function() {
                Track.clearAll();
                $("#bookdata").html("");
                $("#cleardata").css({"visibility": "hidden"});

                var div = document.createElement("div");
                div.attr({"id": "nodata"}).html(nodata_html);
                $("#bookdata").insertChild(div);                              
            };
            showDialogConfirm(conf, yesBtn);
        } else if (type == "go-store") {
            openStore();
        } else {
            var bid = target.attr("data-bid");
            var btitle = target.attr("data-btitle");
            if (!bid) { 
                var p = target.$p(".item");
                if (p) { 
                    var bid = p.attr("data-bid");
                    var btitle = p.attr("data-btitle");
                } else { return false; }
            }

            if (bid) {
                var record = Track.getData(bid, "RECORD");;
                var aindex = 1, page = 1;
                if (record) {
                    aindex = record["aindex"];
                    page = record["page"];
                }
                openRead(bid, aindex, page);
            }
        }
    }

})();
