(function() {

    var defroot = $("#defroot");

    // 最后打开目录存储key
    var DIR_KEY = "local.file.lastdir";

    // 上级目录
    var prevDir = "";
    // 可选择文件
    var selectFile = [];
    // 当前选中数量
    var selectCount = 0;
    // 已选择的文件
    var recordData = [];
    // 文件信息
    var fileList;

    var myScroll;
    function myScrollLoaded() {
        myScroll = new mScroll("wrapper", {
            hScroll: false
        });
    }
    
    $(document).bind("touchmove", function (e) { e.preventDefault(); }, false);
    $(document).bind("DOMContentLoaded", function() {        
        myScrollLoaded();

        try {
            var defRootInfo = fileAPI.defRoot();
            if (defRootInfo) defRootInfo = JSON.parse(defRootInfo);

            var p;
            p = document.createElement("p");
            p.attr({"data-id": "defroot", "data-dir": defRootInfo.sd_root}).html('<span class="local_sd"></span>存储卡');
            defroot.appendChild(p);

            p = document.createElement("p");
            p.attr({"data-id": "defroot", "data-dir": defRootInfo.app_root}).html('<span class="local_stacks"></span>炫色书库');
            defroot.appendChild(p);
            
            // 上次路径
            var last_dir = dataStorage.getItem(DIR_KEY);
            if (last_dir) {
                loadFileList(last_dir);
            } else {
                // 默认目录
                loadFileList(defRootInfo.sd_root);
            }

        } catch (e) {
            debug(e);
        }

    });

    $("#main").bind(CLICK_EVENT, function(e) {
        e.preventDefault();
        
        var target = e.target;

        var data_id = target.attr("data-id");
        var data_type = target.attr("data-type");
        var data_dir = target.attr("data-dir");
        if (!data_id) {
            var p = target.$p("dl.show_do");
            if (p) { 
                data_id = p.attr("data-id");
                data_type = p.attr("data-type");
                data_dir = p.attr("data-dir");
            }
        }

        // 显示更详细一级目录
        if (data_id == "show_do") {
            if (data_type == "dir") {
                loadFileList(data_dir);
            }
        } else if (data_id == "chkfile") { // 选中/取消某个文件
            var value = target.attr("data-value");
            if (typeof value == undefined) return false;
            var checked = target.attr("data-checked");
            if (checked != 1) { // 未选中状态
                target.attr({"src": "img/checkbox2_f.png", "data-id": "chkfile", "data-value": value, "data-checked": 1});
                selectCount++;
                recordLog(value, "add");
            } else { // 取消选中
                target.attr({"src": "img/checkbox2.png", "data-id": "chkfile", "data-value": value, "data-checked": 0});
                selectCount--;
                recordLog(value, "remove");
            }
            joinShelfUpdate();
        }
    });
    
    // 导航条事件
    $("#dir_info").bind(END_EVENT, function(e) {
        e.preventDefault();

        var target = e.target;
        var id = target.attr("data-id");
        switch (id) {
            case "prev_level":
                // 上一级目录
                if (prevDir) {
                    loadFileList(prevDir);
                }
            break;
            case "curr_level":
                showDefRoot();

                // 显示一个背景层
                var wrap = document.createElement("div");
                $("body").insertChild(wrap);

                var iw = window.innerWidth,
                    ih = window.innerHeight;

                wrap.css({"position": "absolute", "zIndex": "7776", "opacity": 1, "top": 0, "left": 0, "width": iw, "height": ih});

                // 绑定事件
                wrap.bind(START_EVENT, function(e) {
                    e.preventDefault();
                    wrap.remove();
                    defroot.removeClass("show").addClass("hide");
                });
            break;
            case "defroot":
                defroot.removeClass("show").addClass("hide");
                var dir = target.attr("data-dir");
                if (dir) {
                    loadFileList(dir);
                }
            break;
        }
    });

    // 底部链接
    $("#bottom-man").bind(END_EVENT, function(e) {
        e.preventDefault();
        
        var target = e.target;
        var dtype = target.attr("data-type");
        if (dtype == "select") {
            var id = target.attr("data-id");
            var obj, img, tmp, checked;
            // 1 全选， 2 反选
            for (var i = 0; i < selectFile.length; i++) {
                obj = $("#chkbox_file_"+selectFile[i]);
                if (obj.id) {                    
                    /**
                     * 选中
                     * 需要先判断，哪些是否已经选中了
                     */
                    tmp = obj.$("img");
                    if (tmp.src) {
                        checked = tmp.attr("data-checked");
                    } else {
                        // 对于没有图片的就认为是已经入库过
                        checked = 1;
                    }
                    if (id == 1 && checked != 1) {
                        selectCount++;
                        recordLog(selectFile[i], "add");
                        img = '<img src="img/checkbox2_f.png" data-id="chkfile" data-value="'+selectFile[i]+'" data-checked="1" />';
                    } else if (id == 2 && checked == 1) { // 取消选中
                        selectCount--;
                        recordLog(selectFile[i], "remove");
                        img = '<img src="img/checkbox2.png" data-id="chkfile" data-value="'+selectFile[i]+'" data-checked="0" />';
                    }
                    obj.html(img);
                }
            }
            joinShelfUpdate();
        } else if (dtype == "shelf") {
            if (recordData.length < 1) {
                showMsg("请先选中要加入书架的文件！");
                return;
            }
            // 加入书架
            var tmp, obj, succ_count = 0;
            for (var i in recordData) {
                tmp = fileList["files"][recordData[i]];
                if (!tmp) continue;                
                // 加入到txt数据库中
                fileAPI.joinShelf(tmp["name"], tmp["dir"]);
                // 更改添加状态
                debug(recordData[i]);
                obj = $("#chkbox_file_"+recordData[i]);
                if (obj.id) {
                    obj.html("已加入");
                    succ_count++;
                }
            }
            // 完成加入之后，更新按钮
            recordData = [];
            selectCount = 0;
            joinShelfUpdate();
            
            // 提示消息
            if (succ_count > 0) {
                showMsg("成功添加("+succ_count+")本图书");
            }
        }
    });

    // 载入列表
    function loadFileList(dir) {
        if (!dir) {
            showMsg("目录错误，请重试！");
            return false;
        }

        // 保存目录地址，下次进入的时候，自动使用
        dataStorage.setItem(DIR_KEY, dir);
        
        var curr_level_html = dir.replace("/mnt/sdcard", "存储卡");
        // 长度超过20个字符，就截取
        if (curr_level_html.length > 20) {
            // 前缀9个字符
            var curr_level_prefix = curr_level_html.substr(0, 9);
            // 尾部11个
            var curr_level_suffix = curr_level_html.substr(-11);

            $("#curr_level").html(curr_level_prefix + "..." + curr_level_suffix);
        } else {
            $("#curr_level").html(curr_level_html);
        }

        var dir_list = $("#dir_list"), p;
        dir_list.empty();
        myScroll.scrollTo(0, 0, 0);

        // 先清空一次
        selectFile = [];
        recordData = [];
        selectCount = 0;
        joinShelfUpdate();
        
        // 文件列表
        fileList = fileAPI.fileList(dir);
        if (fileList) fileList = JSON.parse(fileList);
        
        // 上级目录
        prevDir = fileList.prev_dir;

        var dl, dt, dd, p, div, html, json;
        if (fileList.dir.length > 0) {
            div = document.createElement("div");
            div.setClass("dir_nav").html("文件夹");
            dir_list.appendChild(div);
        }
        // 显示目录列表
        for (var i = 0; i < fileList.dir.length; i++) {
            // 数据
            json = {
                "data-id": "show_do", 
                "data-type": "dir", 
                "data-dir": fileList.dir[i]["dir"]
            };

            dl = document.createElement("dl");
            dl.setClass("show_do").attr(json);

            dt = document.createElement("dt");
            dt.html('<span class="file_type_folder"></span>');
            dl.appendChild(dt);

            dd = document.createElement("dd");
            dl.appendChild(dd);

            // 名称+文件数量
            p = document.createElement("p");
            p.html(fileList.dir[i]["name"]);
            dd.appendChild(p);
            
            html = '<span class="count">'+fileList.dir[i]["count"]+' 项</span>';
            
            p = document.createElement("p");
            p.html(html);
            dd.appendChild(p);

            dir_list.appendChild(dl);
        }
        
        if (fileList.files.length > 0) {
            div = document.createElement("div");
            div.setClass("dir_nav").html("文件");
            dir_list.appendChild(div);
        }
        
        // 显示文件列表
        for (var i = 0; i < fileList.files.length; i++) {
            // 数据
            json = {
                "data-id": "show_do", 
                "data-type": "file", 
                "data-dir": fileList.files[i]["dir"]
            };

            dl = document.createElement("dl");
            dl.setClass("show_do").attr(json);

            dt = document.createElement("dt");
            dt.html('<span class="file_type_txt"></span>');
            dl.appendChild(dt);
            
            dd = document.createElement("dd");
            dl.appendChild(dd);
            
            // 名称+文件大小+日期
            p = document.createElement("p");
            p.html(fileList.files[i]["name"]);
            dd.appendChild(p);

            html = '<span class="size">'+fileList.files[i]["size"]+'</span>';
            html += '<span class="date">'+fileList.files[i]["date"]+'</span>';
            // 判断文件是否已经加入了书架
            var is_join = fileList.files[i]["is_join"];
            if (!is_join) {
                // 可选择的文件
                selectFile.push(i);
                html += '<span class="chkbox" id="chkbox_file_'+i+'"><img src="img/checkbox2.png" data-id="chkfile" data-value="'+i+'" data-checked="0" /></span>';
            } else {
                html += '<span class="chkbox">已加入</span>';
            }
            
            p = document.createElement("p");
            p.html(html);
            dd.appendChild(p);

            dir_list.appendChild(dl);
        }

        myScroll.refresh();
    }

    function showDefRoot(cls) {
        var cls = cls || "show";
        defroot.toggleClass(cls);
    }

    /**
     * 记录或取消选中的文件编号
     * id 文件编号
     * ac add/remove
     */
    function recordLog(id, ac) {
        if (typeof id == undefined) return false;

        if (ac == "add") {
            for (var i in recordData) {
                // 如果已经有了，就不需要添加了
                if (recordData[i] == id) {
                    return;
                }
            }
            recordData.push(id);
        } else if (ac == "remove") {
            for (var i in recordData) {
                if (recordData[i] == id) {
                    recordData.splice(i, 1);
                }
            }
        }
    }

    // 加入书架的数量变化
    function joinShelfUpdate() {
        var join_select = $("#join_select"),
            join_shelf = $("#join_shelf");
        if (selectCount > 0 && selectCount >= selectFile.length) {
            join_select.attr({"data-id": 2}).html("取消全选");
        } else {
            join_select.attr({"data-id": 1}).html("全选");
        }
        if (selectCount > 0) {
            join_shelf.html("加入书架("+selectCount+")");
        } else {
            selectCount = 0;
            join_shelf.html("加入书架");
        }
    }

})();
