/**
 * 阅读章节内容
 *
 * 第一步，刚打开，初始化章节数据，和显示内容
 * 第二步，绑定 btn 还有 txt[] 事件
 webkitRequestFullScreen() 方法可以用来做全屏
 document.webkitCancelFullScreen(); 退出全屏
 */
(function() {
    // {{{ comm
    var btitle = ""; // 书名
    var btype = "local"; // 作品类型
    var bid = 0; // 书号
    var aindex = 0; // 章节索引 查询的时候用索引去查询（方便做百分比）
    var atitle = ""; // 章节标题
    var ctotal = 0; // 总共章节数
    var chapter = ""; // 章节内容
    var txtdata = {}; // comm | content 两个键
    var defaultTxtData = {
        comm: {title: "章节获取失败", vip: 0, isbuy: 0},
        content: "章节内容获取失败或已不存在，请返回尝试重新打开章节，如果还是不行，请关闭重新应用或者阅读下一个章节。\r\n\r\n如果还有问题，请联系客服QQ：867169794"
    };
    // comm }}}
    
    // {{{ btn 
    var daymode = true; // true日间模式|false夜间模式
    var pgmoved = false; // 进度条滑动
    var pghit = false; // 点击进度条
    // btn }}}

    // {{{ txt
    var readmove = $("#readmove");
    var txt = []; // txt 对象句柄
    var mid = []; // txt 对像有居中位置

    var hstxt = 0; // txt2 滚动条高度
    var htxt = 0; // txt2 高
    var wtxt = 0; // txt2 宽

    var lhtxt = 32; // 行高
    var fstxt = 20; // 字号

    var tspos = {x: 0, y: 0}; // 滑动开始的坐标
    var touchMove = false;
    var showTransform = false; // 是否要在滑动完成之后，显示过渡效果
    var menuAllowShow = true; // 是否允许点击显示出菜单
    
    var page = 1;
    var pageCount = 0; // 总页数
    var pagePos = []; // 每一页的位移值
    var pageDir = 'next'; // 翻页方向
    // txt }}}

    // 背景风格
    var bgStyle = {
        "style_huyan": {"backgroundImage": "none", "backgroundColor": "#cde7ce", "color": "#333"},
        "style_yangpi": {"backgroundImage": "url(img/paper.jpg)", "backgroundColor": "transparent", "color": "black"},
        "style_yezhimei": {"backgroundImage": "url(img/bg1.png)", "backgroundColor": "transparent", "color": "#888"},
        "style_shuzhiwei": {"backgroundImage": "url(img/bg5.png)", "backgroundColor": "transparent", "color": "#333"},
        "style_zzling": {"backgroundImage": "url(img/bg2.png)", "backgroundColor": "transparent", "color": "#333"}
    };
    // 对应的字体颜色
    var bgStyleColor = {
        "style_huyan": {"color": "#333"},
        "style_yangpi": {"color": "black"},
        "style_yezhimei": {"color": "#888"},
        "style_shuzhiwei": {"color": "#333"},
        "style_zzling": {"color": "#333"}
    };

    // 预加载新章节
    function preloadNextChapter(aid, _aindex) {
         // 保存数据到SD卡
        if (msxfAPI.allowOffline() == false) {
            return false;
        }

        try {
            var num = 2;
            var networkType = msxfAPI.getNetworkType();
            if (networkType && networkType == 'WIFI') {
                num = 5;
            }

            // 已经存在过的章节，就不要再下载了
            var isExists = false, checkAindex = _aindex + 1, _aid = 0, ignore_id = "";
            for (var i = 0; i < num; i++) {
                isExists = msxfAPI.existChapter(bid, checkAindex);
                if (isExists) {
                    _aid = indexToAid(bid, checkAindex);
                    if (_aid > 0) {
                        ignore_id += _aid+",";
                    }
                }
                checkAindex++;
            }
            
            // 加载新章节，保存到sd卡上面
            var url = server() + '/article/down?bid='+bid+'&aid='+aid+"&num="+num+"&ignore_id="+ignore_id+"&aindex="+_aindex;
            $.jsonp(url, function(ret) {
                if (!ret) {
                    return false;
                }

                if (ret.errno != 0) {
                    return false;
                }

                // 保存章节
                var ai = 0, saveData = '';
                for (var i = 0; i < ret.data.length; i++) {
                    ai = ret.data[i]._aindex;
                    saveData = '§#'+ai+'#§'+ret.data[i].comm_json+"\n"+ret.data[i].content;
                    msxfAPI.saveChapter(bid, ai, saveData);
                }
            }, 'xhr');
        } catch(e) {}
    }
    
    // 加载在线章节 
    function loadOnlineChapter(aid, recall) {
        // 是否要自动保存阅读过的章节
        var autodown = 1;
        var no_autodown = nlg(dataStorage.getItem(systemConfigPrefix+"no-read-autodown"), 0);
        if (no_autodown == 1) autodown = 0;

        // 手机唯一串
        var mobileUniqid = msxfAPI.mobileUniqid();
        var url = server() + '/article/show?bid='+bid+'&aid='+aid+"&sessid="+SID()+"&autodown="+autodown+"&uniqid="+mobileUniqid+"&safe="+SAFE_CODE();
        $.jsonp(url, function(ret) {
            if (!ret) {
                showMsg("章节载入失败，请重试");
                return false;
            }

            if (ret.errno != 0) {
                // -2 VIP章节未登陆提示
                if (ret.errno == -2) {
                    showLoginDialog();
                    return false;
                }

                showMsg(ret.msg);
                return false;
            }

            var data = {
                comm: {"title": ret.title, "vip": ret.vip, "isbuy": ret.isbuy},
                content: ret.content
            };
            
            if (recall && typeof recall == 'function') {
                recall(data);
            }
            
            // 保存数据到SD卡
            try {
                // 如果是订阅成功，记录一个状态
                if (ret.vip == 1 && ret.isbuy == 1) {
                    msxfAPI.saveBuyRecord(bid, parseInt(aid), 'article');
                }

                if (msxfAPI.allowOffline() == true && autodown) {
                    if (ret.encode_content) ret.content = ret.encode_content;
                    var saveData = '§#'+aindex+'#§'+ret.comm_json+"\n"+ret.content;
                    msxfAPI.saveChapter(bid, aindex, saveData);                
                }
            } catch(e) {}

            delete ret;
        }, 'xhr');
    }
    
    /**
     * _aindex 章节索引号
     * recall 回调方法
     */
    function loadChapterData(_aindex, recall) {
        // 将索引号转换成aid
        var aid = indexToAid(bid, _aindex);

        // 第一步，先尝试本地是不是已经有下载        
        var txtdata = msxfAPI.loadText(bid, _aindex);
        if (txtdata == "nodata") txtdata = '';

        if (txtdata) {
            txtdata = JSON.parse(txtdata);
            // 执行回调方法
            if (recall && typeof recall == 'function') {
                recall(txtdata);
            }
        } else { // 没有数据才尝试在线的
            // 检查有没有网络
            if (msxfAPI.onLine() == false) {
                showMsg("网络已掉线，无法载入章节");
                return false;
            }
            
            if (aid <= 0) {
                var callback = setTimeout(function(){
                    openDir(bid, aindex);
                }, 1000);
                showMsg("章节ID错误，请重试").after(callback);
                return false;
            }

            // 第二步，没有下载过的。在线读取
            loadOnlineChapter(aid, function(data) {
                // 执行回调方法
                if (recall && typeof recall == 'function') {
                    recall(data);
                }
            });
        }

        // 是否要自动保存阅读过的章节
        var autodown = 1;
        var no_autodown = nlg(dataStorage.getItem(systemConfigPrefix+"no-read-autodown"), 0);
        if (no_autodown == 1) autodown = 0;

        // 预加载更多章节
        if (msxfAPI.onLine() == true && msxfAPI.allowOffline() == true && autodown) {
            if (aid > 0) preloadNextChapter(aid, _aindex);
        }
    }

    // 初始化数据
    setupInit();

    function setupInit() {
        // 初始化数据
        btitle = nlg(dataStorage.getItem("read.btitle"), "");
        bid = parseInt(dataStorage.getItem("read.bid"));
        aindex = parseInt(nlg(dataStorage.getItem("read.aindex"), 1));
        page = parseInt(nlg(dataStorage.getItem("read.page"), 1));
        
        try {
            if (typeof btitle != "string") btitle = new String(btitle);
            $("#book_name").html(btitle);

            var bookchapter_total = parseInt(nlg(dataStorage.getItem("book.chapter_total."+bid), 0));
            if (bookchapter_total && bookchapter_total > 0) {
                ctotal = bookchapter_total;
            } else {
                // 如果没能正确读取到章节数据，就返回书页一次
                showMsg("章节读取失败，请重试重新打开");
                setTimeout(function() {
                    openBook(bid);
                }, 1000);
                return;
            }
        } catch (e) {
            openBook(bid);
        }  
        
        // 初始化
        doInit();

        // 加载章节内容
        loadChapterData(aindex, function(data) {
            // 没有内容就显示默认的
            if (!data) data = defaultTxtData;

            if (data.comm.vip == 1 && data.comm.isbuy != 1) {
                // 判断是否登陆
                if (!SID()) {
                    showLoginDialog();
                    return false;
                }

                // 判断是否有章节内容
                if (data.content != "") {
                    // 如果取消购买
                    var callback = function() {
                        // 返回上一页
                        go(document.referrer);
                    };
                    showOrderDialog(bid, aindex, callback);
                    return false;
                }
            }
            setChapter(data.content, data.comm.title);

            // 渲染内容
            fillCurrent();
        });

        hideHeadFoot();

        // 横坚屏切换
        window.addEventListener(RESIZE_EVENT, function() {
            calcScreen();
            calcPagePos();
            fillCurrent();
        });
    }

    // 设置章节内容
    function setChapter(txt, title) {        
        try {
            atitle = title;
            // 章节内容 要算上标题
            chapter = "<b>"+title.substr(0, 12)+"</b>" + txt;

            calcPagePos();
            $("#info_title").html(title.substr(0, 24));

            txt = null;
            title = null;
        } catch (e) {}
    }

    // 开始初始化
    function doInit() {
        calcScreen(); // 初始化一些宽高
        initbtnData(); // 初始化按钮设置属性变化
        
        // 绑定几个主要事件
        readmove.bind(START_EVENT, txtStart);
        readmove.bind(END_EVENT, txtEnd);

        // 隐藏层
        $("#hide").bind(START_EVENT, function(e) {
            e.preventDefault();
            hideStart();
            touchMove = false;
            // 由于一个BUG存在,需要在隐藏菜单之后,关闭显示
            menuAllowShow = false;
        });

        // 顶部菜单
        $("#menutop").bind(START_EVENT, function(e) {
            e.preventDefault();
            if (e.target != "" && e.target != null) {
                btnEvent(e);
            }
        });

        // 底部菜单
        $("#menubottom").bind(START_EVENT, function(e) {
            e.preventDefault();
            if (e.target != "" && e.target != null) {
                btnEvent(e);
            }
        });
        
        // 拉动进度条事件
        $("#progress").bind(START_EVENT, progbtnStart);
        // 显示页面
        $("#page").css({"visibility": "visible"});
    }

    // txt 内容对象的一些屏幕参数属性设置
    function calcScreen() {
        var innerWidth = window.innerWidth,
            innerHeight = window.innerHeight,
            info_txt = $("#info_txt"),
            read_txt = $("#read_txt");
        // 保存两个句柄
        txt[1] = $("#txt1"), txt[2] = $("#txt2");

        var txt2PaddingLeft = parseInt(info_txt.css("padding-left")),
            txt2PaddingRight = parseInt(info_txt.css("padding-right")),
            txt2PaddingTop = parseInt(txt[2].css("padding-top")),
            txt2PaddingBottom = parseInt(txt[2].css("padding-bottom"));
        
        var pw = innerWidth - txt2PaddingLeft - txt2PaddingRight;
        var ph = innerHeight - txt2PaddingTop - txt2PaddingBottom;

        // 设置页面宽高
        $("#page").css({"width": innerWidth, "height": innerHeight});
        
        // 初始化
        info_txt.css({"width": innerWidth, "height": ph});
        read_txt.css({"width": innerWidth, "height": ph});

        // 设置 left top
        var txtCss = {"-webkit-transition": "-webkit-transform 0ms", "-webkit-transform": "translateX(0) scale(1)"};
        txt[1].css(txtCss);

        // 设置隐藏层 left top
        var hideCss = {"left": 0, "top": 0, "width": innerWidth, "height": innerHeight};
        $("#hide").css(hideCss);
        readmove.css(hideCss);

        // 对象的居中位置
        mid[1] = parseInt(innerWidth / 3); // txt1 在宽的三分之一位置
        mid[2] = mid[1] * 2 - 30;
        mid[3] = parseInt(innerHeight / 3 / 2); // y轴
        mid[4] = parseInt(innerHeight / 3 * 2);

        wtxt = parseInt(pw); // 文本宽
        htxt = parseInt(info_txt.css("height")); // 文本高
    }

    // 内部方法，初始化设置过的值
    function initbtnData() {
        // 临时变量
        var tmp_read_lh = dataStorage.getItem("read.lineheight"),
            tmp_read_fs = dataStorage.getItem("read.fontsize");
        // 行高和字号
        if (!nl(tmp_read_lh) && !nl(tmp_read_fs)) {
            lhtxt = parseInt(tmp_read_lh);
            fstxt = parseInt(tmp_read_fs);
            txtSetCss({"lineHeight": lhtxt, "fontSize": fstxt});
        }
        $("#show_item_font").html(fstxt);
        
        // 夜间模式
        var tmp_read_mode = dataStorage.getItem("read.mode");
        if (!nl(tmp_read_mode) && tmp_read_mode == 1) {
            daymode = false;
            $("#btn_mode").toggleClass("night_1"); // 夜间模式样式
            // 设置页面背景图片
            var nightCss = {"backgroundImage": "none", "backgroundColor": "#383838", "color": "#bbb"};
            txtSetCss(nightCss);
            txtSetFontColorCss({"color": "#bbb"});
        } else {
            // 阅读背景风格
            var read_style = dataStorage.getItem("read.bgstyle");
            if (read_style) {
                txtSetCss(bgStyle[read_style]);
                txtSetFontColorCss(bgStyleColor[read_style]);

                $("#"+read_style).addClass("style_current");
            }
        }
    }
    
    /**
     * 阅读页面的事件响应
     */
    function btnEvent(e) {
        if (!e) return false;

        var target = e.target;

        var id = target.id;
        var data_id = target.attr("data-id");
        if (data_id) id = data_id;

        if (!id) return false;
        
        switch (id)
        {
            case 'btn_home': // 回首页
                go("shelf.html");
                break;
            case 'btn_back': // 回书页
                openBook(bid);
                break; 
            case 'btn_dir': // 章节列表
                openDir(aindex);
                break;

            case 'btn_bookmark': // 添加书签
                var bookmark_id = "book.mark.record."+bid;
                var bookmark_index = aindex+"-"+page;

                // 保存当前的aindex page
                var bookmark = dataStorage.getItem(bookmark_id);
                if (bookmark) {
                    bookmark = JSON.parse(bookmark);
                    if (bookmark[bookmark_index]) {
                        showMsg("书签已经存在");
                        return;
                    }
                } else {
                    bookmark = {};
                }
                
                var addBookMark = {"aindex": aindex, "page": page, "title": atitle, "time": datetime()};
                bookmark[bookmark_index] = addBookMark;
                dataStorage.setItem(bookmark_id, JSON.stringify(bookmark));
                showMsg("书签添加成功");
                break;
            case 'btn_item_font': // 操作字号
                $("#btn_item").css({"display": "none"});
                $("#option_item").css({"display": "block"});
                $("#option_item .option_item_font").css({"visibility": "visible"});                
                break;

            case 'btn_decr': // 字号变小
                if (fstxt > 16) { 
                    fstxt--;
                    lhtxt--;
                    $("#show_item_font").html(fstxt);
                    fontChange();
                } else {
                    showMsg("字号已经最小，再小就看不见了");
                }
                break;
            case 'btn_incr': // 字号变大
                if (fstxt < 28) { 
                    fstxt++;
                    lhtxt++;
                    $("#show_item_font").html(fstxt);
                    fontChange();
                } else {
                    showMsg("字号已经最大，不能再加大了");
                }
                break;

            case 'btn_style': // 风格
                $("#btn_item").css({"display": "none"});
                $("#option_item").css({"display": "block"});
                $("#option_item .option_item_style").css({"visibility": "visible"});

                // 默认选中状态
                var read_style = dataStorage.getItem("read.bgstyle");
                if (!read_style) read_style = 'style_huyan';
                $("#"+read_style).addClass("style_current");
                break;

            case 'btn_style_option': // 设置风格
                var read_style = target.attr("id");
                if (read_style) {
                    txtSetCss(bgStyle[read_style]);
                    txtSetFontColorCss(bgStyleColor[read_style]);

                    // 选中状态
                    $("#option_item").$s(".style_option").forEach(function(e) {
                        try {
                            if (e.id && e.id == read_style) {
                                e.addClass("style_current");
                            } else {
                                e.removeClass("style_current");
                            }
                        } catch (e) {}
                    });

                    dataStorage.setItem("read.bgstyle", read_style);
                }
                break;

            case 'btn_mode': // 切换模式 白天|晚上
                if (daymode) {
                    daymode = false;
                    $('#btn_mode').setClass("icon_item_bright2");

                    var nightCss = {"backgroundImage": "none", "backgroundColor": "#383838", "color": "#888"};
                    txtSetCss(nightCss);
                    txtSetFontColorCss({"color": "#bbbbbb"});

                    dataStorage.setItem("read.mode", 1);
                    dataStorage.setItem("read.bgstyle", "style_yezhimei");
                } else {
                    daymode = true;
                    $('#btn_mode').setClass("icon_item_bright");

                    var nightCss = {"backgroundImage": "none", "backgroundColor": "#cde7ce", "color": "#333"};
                    txtSetCss(nightCss);
                    txtSetFontColorCss({"color": "#333"});

                    dataStorage.setItem("read.mode", 0);
                    dataStorage.setItem("read.bgstyle", "style_huyan");
                }

                // 选中状态
                $("#option_item").$s(".style_option").forEach(function(e) {
                    try {
                        e.removeClass("style_current");
                    } catch (e) {}
                });
                break;

            case 'btn_progress': // 进度条
                $("#btn_item").css({"display": "none"});
                $("#option_item").css({"display": "block"});
                $("#option_item .option_item_progress").css({"visibility": "visible"});
                break;
            case 'progress_prev': // 上一章
                txtPrev(1);
                break;
            case 'progress_next': // 下一章
                page = pageCount + 1;
                txtNext();
                break;
        }
    }

    // 设置txt的属性 2个
    function txtSetCss(css) {
        txt[1].css(css);
        txt[2].css(css);
    }

    // 设置txt相应的字体颜色
    function txtSetFontColorCss(fontCss) {
        $("#info_title").css(fontCss);
        $("#info_foot").css(fontCss);
        $("#read_title").css(fontCss);
        $("#read_foot").css(fontCss);
    }

    // 执行字号改变
    function fontChange() {
        dataStorage.setItem("read.lineheight", lhtxt);
        dataStorage.setItem("read.fontsize", fstxt);

        txtSetCss({"lineHeight": lhtxt, "fontSize": fstxt});        

        // 计算分页并显示内容
        calcPagePos();
        fillCurrent();
    }

    // 进度条移动
    function progbtnStart(e) {
        e.preventDefault();

        var target = e.target;
        target.bind(MOVE_EVENT, progbtnMove);
        target.bind(END_EVENT, progbtnEnd);

        pgmoved = false;

        if (typeof e.touches !== "undefined") {
            var x = e.touches[0].clientX;
        } else {
            var x = e.pageX;
        }

        var w = parseInt($("#progbar").css("width"));
        
        // 移动的位置超过50个相素才开始有动作
        pghit = Math.abs(x - 50 - w) < 50;
    }
    
    // 进度条移动中
    function progbtnMove(e) {
        e.preventDefault();

        if (typeof e.touches !== "undefined") {
            var x = e.touches[0].clientX;
        } else {
            var x = e.pageX;
        }
        var w = parseInt($("#progress").css("width"));
        
        // 在当前位置 50 个相素以内，左右可以拖动
        if (pghit && x >= 50 && x <= 50 + w) {
            // 计算百分比
            var a = ((x - 50) / w * 100).toFixed(1);

            $("#progtip").html(a + "%");
            $("#progtip2").html(a + "%");

            $("#progbar").css({"width": a + "%"});
            $("#progbtn").css({"left": (a - 1) + "%"});
             
            // aindex 章节顺序索引
            aindex = parseInt(a / (100 / ctotal));
            
            if (aindex < 1) {
                aindex = 1;
            } else {
                if (aindex > ctotal) {
                    aindex = ctotal;
                }
            }

            pgmoved = true;
        }
    }
    
    // 松开进度条
    function progbtnEnd(e) {
        e.preventDefault();

        var target = e.target;
        target.unbind(MOVE_EVENT, progbtnMove);
        target.unbind(END_EVENT, progbtnEnd);

        if (pgmoved) {
            hideStart();
            // 重新载入内容
            loadChapterData(aindex, function(data) {
                // 没有内容就显示默认的
                if (!data) data = defaultTxtData;

                // 如果是VIP章节，但是没有购买过，就给出提示
                if (data.comm.vip == 1 && data.comm.isbuy != 1) {
                    // 判断是否登陆
                    if (!SID()) {
                        showLoginDialog();
                        return false;
                    }

                    showOrderDialog(bid, aindex);
                    return false;
                }

                setChapter(data.content, data.comm.title);
                
                page = 1;
                // 计算分页并显示内容
                calcPagePos();
                fillCurrent(1);
            });
        }
    }
    
    // 阅读百分比
    function showProgress() {
        var a = calcPercent();
        $("#progtip").html(a + "%");
        $("#progtip2").html(a + "%");

        $("#progbar").css({"width": a + "%"});
        $("#progbtn").css({"left": (a - 1) + "%"});
    }
    
    // 别的操作时，直接隐藏
    function hideStart() {
        var hidecss = {"visibility": "hidden"};
        $("#hide").css(hidecss);
        $("#menutop").css(hidecss);
        $("#menubottom").css(hidecss);

        $("#option_item").css({"display": "none"});
        
        // 具体的选项 都要隐藏掉
        $("#option_item .option_item_font").css(hidecss);
        $("#option_item .option_item_progress").css(hidecss);
        $("#option_item .option_item_style").css(hidecss);
    }

    // 显示菜单
    function showMenu() {
        // 显示上下导航条
        var showcss = {"visibility": "visible"};
        $("#hide").css(showcss);
        $("#menutop").css(showcss);
        $("#menubottom").css(showcss);
        $("#btn_item").css({"display": "block"});
    }
        
    // 文本滑动开始
    function txtStart(e) {
        e.preventDefault();
        
        if (touchMove) return;

        var target = e.target;
        
        if (typeof e.touches !== "undefined") {
            tspos.x = e.touches[0].clientX;
            tspos.y = e.touches[0].clientY;
        } else {
            tspos.x = e.pageX;
            tspos.y = e.pageY;
        }        
        touchMove = false;
        menuAllowShow = true;
        showTransform = false;

        readmove.bind(MOVE_EVENT, txtMove);
        
        var txt1Css = {"-webkit-transform": "translateX(0) scale(1)", "-webkit-transition": "-webkit-transform 0ms"};
        txt[1].css(txt1Css);

        if (tspos.x <= mid[1]) { // 上一章
            if (page <= 1 && aindex <= 1) {
                showMsg("已经到第一页，前面没有了");
                return;
            }
            touchMove = true;
            pageDir = 'prev';
            txtPrev();

            var iw = window.innerWidth + 10;
            txt1Css = {"display": "block", "-webkit-transform": "translateX(-"+iw+"px) scale(1)"};
        } else if (tspos.x >= mid[2] || tspos.y <= mid[3] || tspos.y >= mid[4]) { // 下一章
            // 已经是最后一页了
            if (page >= pageCount && aindex >= ctotal) {
                showReadEnd();
                return;
            }
            touchMove = true;
            pageDir = 'next';
            copyBaseInfo();
            // 将当前txt2,复制给txt1
            var info_txt_content = $("#info_txt").html();
            if (info_txt_content) $("#read_txt").html(info_txt_content);
            txtNext();

            txt1Css = {"display": "block", "-webkit-transform": "translateX(0) scale(1)"};
        }
        txt[1].css(txt1Css);
    }

    function txtMove(e) {
        e.preventDefault();

        if (typeof e.touches !== "undefined") {
            var currentX = e.touches[0].clientX;
        } else {
            var currentX = e.pageX;
        }
        
        if (!touchMove) {
            // 翻动超过 n 相素 就判断上/下页
            touchMove  = Math.abs(currentX - tspos.x) > 10;
            if (touchMove) {
                // 上一页
                if (currentX > tspos.x) {
                    if (page <= 1 && aindex <= 1) {
                        showMsg("已经到第一页，前面没有了");
                        return;
                    }
                    pageDir = 'prev';
                    txtPrev();
                } else { 
                    // 已经是最后一页了
                    if (page >= pageCount && aindex >= ctotal) {
                        showReadEnd();
                        return;
                    }
                    pageDir = 'next';
                    copyBaseInfo();
                    // 将当前txt2,复制给txt1
                    var info_txt_content = $("#info_txt").html();
                    if (info_txt_content) $("#read_txt").html(info_txt_content);
                    txtNext();
                }
                txt[1].css({"display": "block"});
            }
        }
        
        // 滑动txt[1]
        var iw = window.innerWidth;
        var t = Math.min(Math.max(currentX, 0), iw);
        // 下一页，特殊处理
        if (pageDir == "next") {
            var xpos = tspos.x - t;
        } else {
            var xpos = iw - t;
        }

        txt[1].css({"-webkit-transform": "translateX(-"+xpos+"px) scale(1)"});
    }

    function txtEnd(e) {
        e.preventDefault();

        readmove.unbind(MOVE_EVENT, txtMove);

        if (!touchMove) {
            // 点中间位置才显示菜单
            // 点中间位置才显示菜单
            if (tspos.x >= mid[1] && tspos.x <= mid[2] &&
                tspos.y >= mid[3] && tspos.y <= mid[4] && menuAllowShow) {
                showMenu()
            }
        }
        // 复位
        resetTxtPage();
    }

    // 上一章
    function txtPrev(initPage) {
        if (page <= 1) {
            if (aindex <= 1) {
                showMsg("已到第一页，前面没有内容了");
                return;
            } else {
                loadChapterData(aindex - 1, function(data) {
                    // 没有内容就显示默认的
                    if (!data) data = defaultTxtData;

                    // 如果是VIP章节，但是没有购买过，就给出提示
                    if (data.comm.vip == 1 && data.comm.isbuy != 1) {
                        // 判断是否登陆
                        if (!SID()) {
                            showLoginDialog();
                            return false;
                        }
                        showOrderDialog(bid, aindex-1);
                        return false;
                    }

                    setChapter(data.content, data.comm.title);                    

                    // 载入成功之后再减1 防止快速刷新
                    aindex--;
                    
                    page = initPage || pageCount;
                    fillCurrent(1);
                });
            }
        } else {
            if (page > 1) {
                page--;
            } else {
                page = 1;
            }
            fillCurrent();
        }
    }
    
    // 下一章
    function txtNext() {
        // 判断一个章节有没有读完
        if (page >= pageCount) {
            // 是否到最后一页
            if (aindex >= ctotal) {
                showReadEnd();
                return;
            } else {
                loadChapterData(aindex + 1, function(data) {
                    // 没有内容就显示默认的
                    if (!data) data = defaultTxtData;

                    // 如果是VIP章节，但是没有购买过，就给出提示
                    if (data.comm.vip == 1 && data.comm.isbuy != 1) {
                        // 判断是否登陆
                        if (!SID()) {
                            showLoginDialog();
                            return false;
                        }
                        showOrderDialog(bid, aindex+1);
                        return false;
                    }

                    setChapter(data.content, data.comm.title);

                    // 载入成功之后再加1，防止跳过
                    aindex++;

                    page = 1;
                    fillCurrent(1);
                });
            }
        } else {
            // 同一个章节没有读完，分成了多页
            page++;
            fillCurrent();
        }
    }

    // 计算章节分页
    function calcPagePos() {
        var w_count = parseInt(wtxt / fstxt); // 行宽
        var h_count = parseInt(htxt / lhtxt);

        // 调整位置
        var str_count = 1; // 字数出现次数，每次有换行的时候，置0
        var newline_count = 1; // 换行 \n 出现的次数
        var tmp_char = '';
        pageCount = 1;
        for (head = 0; head <= chapter.length; head++) {
            tmp_char = chapter.charAt(head);
            // 碰到换行符
            if (tmp_char == "\n") { 
                newline_count++;
                str_count = 0;
            } else {
                // 特殊字符，要加2
                if (tmp_char == "…") {
                    str_count += 2;
                } else {
                    str_count++;
                }
                // 每行的字数达到 文本行宽的时候 换一次行
                if (str_count >= w_count) {
                    newline_count++;
                    str_count = 0;
                }
            }
            // 换行次数达到 页高的时候，计算出一页
            if (newline_count >= h_count) {
                pagePos[pageCount] = [head];
                // 复位
                newline_count = str_count = 1;
                pageCount++;

                // 最后那一段不足一页的部分
            } else if (head + 1 >= chapter.length) {
                pagePos[pageCount] = [head];
            }
        }
    }
    
    // 显示内容
    function fillCurrent(animation) {
        // 默认从第一页开始
        if (page < 1) page = 1;
        if (page > pageCount) page = pageCount;

        var start = 0;
        var limit = pagePos[page][0];
        if (page > 1) {
            start = pagePos[page-1][0] + 1;
        }

        var output_html = chapter.substring(start, limit + 1).replace(/\n/g, "<br>");
        if (pageDir == "prev") {
            $("#read_txt").html(output_html);
            copyBaseInfo();
        } else {
            $("#info_txt").html(output_html);
        }

        // 当前章节分页号
        $("#chapter_page").html(page+"/"+pageCount);

        showTransform = true;
        
        recordPosition();
        showProgress();

        // 当载入新章节时，需要主动触发切换动画
        if (animation) resetTxtPage();
    }
    
    // 计算阅读百分比
    function calcPercent() {
        return ((aindex - 1) / ctotal * 100 + 100 / ctotal * ((page + 1) / pageCount)).toFixed(1);
    }

    // 记录阅读位置
    function recordPosition() {
        dataStorage.setItem("read.aindex", aindex);
        dataStorage.setItem("read.page", page);
        // 保存阅读位置记录
        var record = {"aindex": aindex, "page": page, "percent": calcPercent() + "%"};
        Track.putData(bid, record, 'RECORD');
    }

    // 设置头部和顶部信息
    function hideHeadFoot() {
        var noneCss = {"display": "none"};
        var showCss = {"display": "block"};

        try {
            var info_title = $("#info_title"), 
                info_foot = $("#info_foot"),
                read_title = $("#read_title"),
                read_foot = $("#read_foot");

            // 隐掉头部
            var no_read_title = dataStorage.getItem(systemConfigPrefix+"no-read-title");
            if (parseInt(no_read_title) == 1) {
                info_title.css(noneCss);
                read_title.css(noneCss);
            } else {
                info_title.css(showCss);
                read_title.css(showCss);
            }

            // 隐掉底部
            var no_foot_title = dataStorage.getItem(systemConfigPrefix+"no-read-foot");
            if (parseInt(no_foot_title) == 1) {
                info_foot.css(noneCss);
                read_foot.css(noneCss);
            } else {
                info_foot.css(showCss);
                read_foot.css(showCss);
            }

        } catch (e) {}
    }

    // 复位txt1
    function resetTxtPage() {
        var iw = pageDir == 'next' ? -window.innerWidth-20 : 0;
        txt[1].css({"-webkit-transform": "translateX("+iw+"px) scale(1)"});
        // 是否要显示过渡效果
        if (showTransform) {
            txt[1].css({"-webkit-transition": "all .3s"});
        }

        // 上一页的时候，当停下来之后，需要将位置进行交换
        if (pageDir == 'prev') {
            setTimeout(function() {
                var read_txt_content = $("#read_txt").html();
                if (read_txt_content) {
                    $("#info_txt").html(read_txt_content);
                }
                hidePrevPageBox();
            }, 380);
        } else {
            setTimeout(function() {
                hidePrevPageBox();
            }, 380);
        }

        // 滑动要复位为false,下次才可以继续
        touchMove = false;
    }
    
    // 复制基本信息用于翻页
    function copyBaseInfo() {
        try {
            $("#read_title").html($("#info_title").html());
            $("#read_progtip").html($("#progtip").html());
            $("#read_book_name").html($("#book_name").html());
            $("#read_chapter_page").html($("#chapter_page").html());
        } catch(e) {}
    }

    // 隐藏上一页
    function hidePrevPageBox() {
        txt[1].css({"display": "none", "-webkit-transform": "translateX(0) scale(1)", "-webkit-transition": "-webkit-transform 0ms"});

        $("#read_title").html("");
        $("#read_progtip").html("");
        $("#read_book_name").html("");
        $("#read_chapter_page").html("");
        $("#read_txt").html("");
    }

    // 提示作品阅读完了
    function showReadEnd() {
        var iw = window.innerWidth;
        var ih = window.innerHeight;

        var doc = document, ul, li;

        var wrapObj = $("#comm_info_readend_wrap");
        var dialogObj = $("#comm_info_readend");

        // 检查对话框是不是已经创建出来过了，因为$方法总是返回一个对象
        if (wrapObj.id && dialogObj.id) return;

        // 背景
        var wrap = doc.createElement("div");
        wrap.css({"position": "absolute", "zIndex": "5555", "visibility": "visible", "backgroundColor": "#908E8F", "opacity": 0.45, "top": 0, "left": 0, "width": iw, "height": ih});
        wrap.attr({"id": "comm_info_readend_wrap"});
        $("body").insertChild(wrap);

        // 显示确认框
        var dialog = doc.createElement("div");
        dialog.setClass("comm_info_readend").attr({"id": "comm_info_readend"});

        // title
        var dialog_title = doc.createElement("div");
        dialog_title.setClass("comm_dialog_title").html('阅读提示');
        dialog.insertChild(dialog_title);

        // 提示
        var dialog_body = doc.createElement("div");
        dialog_body.setClass("info");
        dialog.insertChild(dialog_body);

        ul = doc.createElement("ul");
        dialog_body.insertChild(ul);

        li = doc.createElement("li");
        li.html('<p>当前作品已经阅读完毕，炫色书城还有大量优质作品；欢迎进入书城继续阅读！</p>');
        ul.insertChild(li);

        li = doc.createElement("li");
        li.setClass("btn").html('<span data-id="store" class="btn_color_green">进入书城</span>&nbsp;&nbsp;&nbsp;&nbsp;<span data-id="shelf" class="btn_color_blue2">返回书架</span>');
        ul.insertChild(li);

        $("body").insertChild(dialog);

        dialog.bind(START_EVENT, function(e) {
            e.preventDefault();

            var target = e.target;

            if (target != null) {
                var id = target.attr("data-id");
                if (!id) return false;
 
                if (id == "store") {
                    openStore();
                } else if (id == "shelf") {
                    openShelf();
                }
            }
        });

        dialog.bind(MOVE_EVENT, function(e) { 
            e.preventDefault();
        });
        dialog.bind(END_EVENT, function(e) {
            e.preventDefault();
        });

        // 返回
        wrap.bind(START_EVENT, function(e) {
            e.preventDefault();
            dialog.remove();
            wrap.remove();
        });
    }

})();
