/**
 * 阅读章节内容
 */
(function() {
    // {{{ comm
    var btitle = ""; // 书名
    var btype = "txt"; // 作品类型
    var ctotal = 0; // 总共字数
    var chapter = ""; // 章节内容
    var defaultTxtData = {
        content: "章节内容获取失败或已不存在，请返回尝试重新打开章节，如果还是不行，请关闭重新应用或者阅读下一个章节。\r\n\r\n如果还有问题，请联系客服QQ：867169794"
    };
    // comm }}}

    // {{{ txt
    var readmove = $("#readmove");
    var txt = []; // txt 对象句柄
    var mid = []; // txt 对像有居中位置

    var hstxt = 0; // txt2 滚动条高度
    var htxt = 0; // txt2 高
    var wtxt = 0; // txt2 宽

    var lhtxt = 32; // 行高
    var fstxt = 20; // 字号

    var line_word = 8; // 每行多少字
    var line_count = 8; // 每屏多少行

    var tspos = {x: 0, y: 0}; // 滑动开始的坐标
    var touchMove = false;
    var showTransform = false; // 是否要在滑动完成之后，显示过渡效果
    var menuAllowShow = true; // 是否允许点击显示出菜单
    
    var page = 0;
    var pageCount = 1; // 总页数
    var pageWord = 100; // 每页的字数
    var pageDir = 'next'; // 翻页方向
    // txt }}}

    /**
     * 加载TXT内容
     */
    function loadChapter() {
        var txtdata = fileAPI.chapter(path, page, line_word, line_count);
        if (txtdata == "nodata") txtdata = '';
        if (txtdata) {
            txtdata = JSON.parse(txtdata);
            // 总字数
            ctotal = txtdata.ctotal;
            return txtdata.content;
        }
        
        return defaultTxtData;        
    }
    
    // 初始化数据
    setupInit();

    function setupInit() {
        // 初始化数据
        btitle = nlg(dataStorage.getItem("read.txt.name"), "test");
        path = nlg(dataStorage.getItem("read.txt.path"), "");
        page = parseInt(nlg(dataStorage.getItem("read.txt.page"), 0));

        try {
            if (typeof btitle != "string") btitle = new String(btitle);
            $("#book_name").html(btitle);
        } catch (e) {
            openShelf();
        }
        
        // 初始化
        doInit();

        // 加载章节内容
        var content = loadChapter();
        if (content) {
            setChapter(content, btitle);
            // 渲染内容
            fillCurrent();
        }

        hideHeadFoot();

        // 横坚屏切换
        window.addEventListener(RESIZE_EVENT, function() {
            calcScreen();
            calcPagePos();
            fillCurrent();
        });
    }

    // 设置章节内容
    function setChapter(txt) {        
        try {
            // 章节内容 要算上标题
            chapter = "<b>"+btitle.substr(0, 12)+"</b>" + txt;
            calcPagePos();
            txt = null;
        } catch (e) {}
    }

    // 开始初始化
    function doInit() {
        calcScreen(); // 初始化一些宽高
        
        // 绑定几个主要事件
        readmove.bind(START_EVENT, txtStart);
        readmove.bind(END_EVENT, txtEnd);

        // 隐藏层
        $("#hide").bind(START_EVENT, function(e) {
            e.preventDefault();
            hideStart();
            touchMove = false;
            // 由于一个BUG存在,需要在隐藏菜单之后,关闭显示
            menuAllowShow = false;
        });

        // 顶部菜单
        $("#menutop").bind(START_EVENT, function(e) {
            e.preventDefault();
            if (e.target != "" && e.target != null) {
                btnEvent(e);
            }
        });

        // 显示页面
        $("#page").css({"visibility": "visible"});
    }

    // txt 内容对象的一些屏幕参数属性设置
    function calcScreen() {
        var innerWidth = window.innerWidth,
            innerHeight = window.innerHeight,
            info_txt = $("#info_txt"),
            read_txt = $("#read_txt");
        // 保存两个句柄
        txt[1] = $("#txt1"), txt[2] = $("#txt2");

        var txt2PaddingLeft = parseInt(info_txt.css("padding-left")),
            txt2PaddingRight = parseInt(info_txt.css("padding-right")),
            txt2PaddingTop = parseInt(txt[2].css("padding-top")),
            txt2PaddingBottom = parseInt(txt[2].css("padding-bottom"));
        
        var pw = innerWidth - txt2PaddingLeft - txt2PaddingRight;
        var ph = innerHeight - txt2PaddingTop - txt2PaddingBottom;

        // 设置页面宽高
        $("#page").css({"width": innerWidth, "height": innerHeight});
        
        // 初始化
        info_txt.css({"width": innerWidth, "height": ph});
        read_txt.css({"width": innerWidth, "height": ph});

        // 设置 left top
        var txtCss = {"-webkit-transition": "-webkit-transform 0ms", "-webkit-transform": "translateX(0) scale(1)"};
        txt[1].css(txtCss);

        // 设置隐藏层 left top
        var hideCss = {"left": 0, "top": 0, "width": innerWidth, "height": innerHeight};
        $("#hide").css(hideCss);
        readmove.css(hideCss);

        // 对象的居中位置
        mid[1] = parseInt(innerWidth / 3); // txt1 在宽的三分之一位置
        mid[2] = mid[1] * 2 - 30;
        mid[3] = parseInt(innerHeight / 3 / 2); // y轴
        mid[4] = parseInt(innerHeight / 3 * 2);

        wtxt = parseInt(pw); // 文本宽
        htxt = parseInt(info_txt.css("height")); // 文本高
        
        // 初始化的时候，就要计算出每页显示字数
        calcPageWord();
    }
    
    /**
     * 阅读页面的事件响应
     */
    function btnEvent(e) {
        if (!e) return false;

        var target = e.target;

        var id = target.id;
        var data_id = target.attr("data-id");
        if (data_id) id = data_id;

        if (!id) return false;
        
        switch (id)
        {
            case 'btn_home': // 回首页
                openShelf();
                break;

            case 'btn_item_font': // 操作字号
                $("#btn_item").css({"display": "none"});
                $("#option_item").css({"display": "block"});
                $("#option_item .option_item_font").css({"visibility": "visible"});                
                break;

            case 'btn_decr': // 字号变小
                if (fstxt > 16) { 
                    fstxt--;
                    lhtxt--;
                    $("#show_item_font").html(fstxt);
                    fontChange();
                } else {
                    showMsg("字号已经最小，再小就看不见了");
                }
                break;
            case 'btn_incr': // 字号变大
                if (fstxt < 28) { 
                    fstxt++;
                    lhtxt++;
                    $("#show_item_font").html(fstxt);
                    fontChange();
                } else {
                    showMsg("字号已经最大，不能再加大了");
                }
                break;

            case 'btn_style': // 风格
                $("#btn_item").css({"display": "none"});
                $("#option_item").css({"display": "block"});
                $("#option_item .option_item_style").css({"visibility": "visible"});

                // 默认选中状态
                var read_style = dataStorage.getItem("read.bgstyle");
                if (!read_style) read_style = 'style_huyan';
                $("#"+read_style).addClass("style_current");
                break;

            case 'btn_style_option': // 设置风格
                var read_style = target.attr("id");
                if (read_style) {
                    txtSetCss(bgStyle[read_style]);
                    txtSetFontColorCss(bgStyleColor[read_style]);

                    // 选中状态
                    $("#option_item").$s(".style_option").forEach(function(e) {
                        try {
                            if (e.id && e.id == read_style) {
                                e.addClass("style_current");
                            } else {
                                e.removeClass("style_current");
                            }
                        } catch (e) {}
                    });

                    //dataStorage.setItem("read.bgstyle", read_style);
                }
                break;

            case 'btn_mode': // 切换模式 白天|晚上
                if (daymode) {
                    daymode = false;
                    $('#btn_mode').setClass("icon_item_bright2");

                    var nightCss = {"backgroundImage": "none", "backgroundColor": "#383838", "color": "#888"};
                    txtSetCss(nightCss);
                    txtSetFontColorCss({"color": "#bbbbbb"});

                    //dataStorage.setItem("read.mode", 1);
                    //dataStorage.setItem("read.bgstyle", "style_yezhimei");
                } else {
                    daymode = true;
                    $('#btn_mode').setClass("icon_item_bright");

                    var nightCss = {"backgroundImage": "none", "backgroundColor": "#cde7ce", "color": "#333"};
                    txtSetCss(nightCss);
                    txtSetFontColorCss({"color": "#333"});

                    //dataStorage.setItem("read.mode", 0);
                    //dataStorage.setItem("read.bgstyle", "style_huyan");
                }

                // 选中状态
                $("#option_item").$s(".style_option").forEach(function(e) {
                    try {
                        e.removeClass("style_current");
                    } catch (e) {}
                });
                break;

            case 'btn_progress': // 进度条
                $("#btn_item").css({"display": "none"});
                $("#option_item").css({"display": "block"});
                $("#option_item .option_item_progress").css({"visibility": "visible"});
                break;
            case 'progress_prev': // 上一章
                txtPrev(1);
                break;
            case 'progress_next': // 下一章
                page = pageCount + 1;
                txtNext();
                break;
        }
    }

    // 设置txt的属性 2个
    function txtSetCss(css) {
        txt[1].css(css);
        txt[2].css(css);
    }

    // 设置txt相应的字体颜色
    function txtSetFontColorCss(fontCss) {
        $("#info_title").css(fontCss);
        $("#info_foot").css(fontCss);
        $("#read_title").css(fontCss);
        $("#read_foot").css(fontCss);
    }

    // 执行字号改变
    function fontChange() {
        //dataStorage.setItem("read.lineheight", lhtxt);
        //dataStorage.setItem("read.fontsize", fstxt);

        txtSetCss({"lineHeight": lhtxt, "fontSize": fstxt});        

        // 计算分页并显示内容
        fillCurrent();
    }
    
    // 阅读百分比
    function showProgress() {
        var a = calcPercent();
        $("#progtip").html(a + "%");
    }
    
    // 别的操作时，直接隐藏
    function hideStart() {
        var hidecss = {"visibility": "hidden"};
        $("#hide").css(hidecss);
        $("#menutop").css(hidecss);
    }

    // 显示菜单
    function showMenu() {
        // 显示上下导航条
        var showcss = {"visibility": "visible"};
        $("#hide").css(showcss);
        $("#menutop").css(showcss);
    }
        
    // 文本滑动开始
    function txtStart(e) {
        e.preventDefault();
        
        if (touchMove) return;

        var target = e.target;
        
        if (typeof e.touches !== "undefined") {
            tspos.x = e.touches[0].clientX;
            tspos.y = e.touches[0].clientY;
        } else {
            tspos.x = e.pageX;
            tspos.y = e.pageY;
        }        
        touchMove = false;
        showTransform = false;
        menuAllowShow = true;

        readmove.bind(MOVE_EVENT, txtMove);
        
        var txt1Css = {"-webkit-transform": "translateX(0) scale(1)", "-webkit-transition": "-webkit-transform 0ms"};
        txt[1].css(txt1Css);

        if (tspos.x <= mid[1]) { // 上一章
            if (page < 1) {
                showMsg("已经到第一页，前面没有了");
                return;
            }
            touchMove = true;
            pageDir = 'prev';
            txtPrev();

            var iw = window.innerWidth + 10;
            txt1Css = {"display": "block", "-webkit-transform": "translateX(-"+iw+"px) scale(1)"};
        } else if (tspos.x >= mid[2] || tspos.y <= mid[3] || tspos.y >= mid[4]) { // 下一章
            // 已经是最后一页了
            if (page >= pageCount) {
                showReadEnd();
                return;
            }
            touchMove = true;
            pageDir = 'next';
            copyBaseInfo();
            // 将当前txt2,复制给txt1
            var info_txt_content = $("#info_txt").html();
            if (info_txt_content) $("#read_txt").html(info_txt_content);
            txtNext();

            txt1Css = {"display": "block", "-webkit-transform": "translateX(0) scale(1)"};
        }
        txt[1].css(txt1Css);
    }

    function txtMove(e) {
        e.preventDefault();

        if (typeof e.touches !== "undefined") {
            var currentX = e.touches[0].clientX;
        } else {
            var currentX = e.pageX;
        }
        
        if (!touchMove) {
            // 翻动超过 n 相素 就判断上/下页
            touchMove  = Math.abs(currentX - tspos.x) > 10;
            if (touchMove) {
                // 上一页
                if (currentX > tspos.x) {
                    if (page < 1) {
                        showMsg("已经到第一页，前面没有了");
                        return;
                    }
                    pageDir = 'prev';
                    txtPrev();
                } else { 
                    // 已经是最后一页了
                    if (page >= pageCount) {
                        showReadEnd();
                        return;
                    }
                    pageDir = 'next';
                    copyBaseInfo();
                    // 将当前txt2,复制给txt1
                    var info_txt_content = $("#info_txt").html();
                    if (info_txt_content) $("#read_txt").html(info_txt_content);
                    txtNext();
                }
                txt[1].css({"display": "block"});
            }
        }
        
        // 滑动txt[1]
        var iw = window.innerWidth;
        var t = Math.min(Math.max(currentX, 0), iw);
        // 下一页，特殊处理
        if (pageDir == "next") {
            var xpos = tspos.x - t;
        } else {
            var xpos = iw - t;
        }

        txt[1].css({"-webkit-transform": "translateX(-"+xpos+"px) scale(1)"});
    }

    function txtEnd(e) {
        e.preventDefault();

        readmove.unbind(MOVE_EVENT, txtMove);

        if (!touchMove) {
            // 点中间位置才显示菜单
            // 点中间位置才显示菜单
            if (tspos.x >= mid[1] && tspos.x <= mid[2] &&
                tspos.y >= mid[3] && tspos.y <= mid[4] && menuAllowShow) {
                showMenu()
            }
        }
        // 复位
        resetTxtPage();
    }

    // 上一章
    function txtPrev() {
        if (page < 1) {
            showMsg("已到第一页，前面没有内容了");
            return;
        } else {
            if (page > 0) {
                page--;
            } else {
                page = 1;
            }
            var content = loadChapter();
            if (content) {
                setChapter(content, btitle);
                // 渲染内容
                fillCurrent();
            }
        }
    }
    
    // 下一章
    function txtNext() {
        // 判断一个章节有没有读完
        if (page >= pageCount) {
            showReadEnd();
            return;
        } else {
            page++;
            var content = loadChapter();
            if (content) {
                setChapter(content, btitle);
                // 渲染内容
                fillCurrent();
            }
        }
    }

    // 计算每页显示字数
    function calcPageWord() {
        line_word = parseInt(wtxt / fstxt);
        line_count = parseInt(htxt / lhtxt);
        pageWord = line_word * line_count;
    }

    // 计算章节分页
    function calcPagePos() {
        calcPageWord();
        pageCount = Math.ceil(ctotal / pageWord);
        debug("pageWord:" + pageWord + ",pageCount:" + pageCount);
    }
    
    // 显示内容
    function fillCurrent(animation) {
        var output_html = chapter.replace(/\n/g, "<br>");
        if (pageDir == "prev") {
            $("#read_txt").html(output_html);
            copyBaseInfo();
        } else {
            $("#info_txt").html(output_html);
        }

        showTransform = true;
        
        recordPosition();
        showProgress();

        // 当载入新章节时，需要主动触发切换动画
        if (animation) resetTxtPage();
    }
    
    // 计算阅读百分比
    function calcPercent() {
        return (100 / pageCount * ((page + 1) / pageCount)).toFixed(1);
    }

    // 记录阅读位置
    function recordPosition() {
        //dataStorage.setItem("read.txt.page", page);
        // 保存阅读位置记录
        //var record = {"page": page, "percent": calcPercent() + "%"};
        //Track.putData(bid, record, 'RECORD');
    }

    // 设置头部和顶部信息
    function hideHeadFoot() {
        var noneCss = {"display": "none"};
        var showCss = {"display": "block"};

        try {
            var info_title = $("#info_title"), 
                info_foot = $("#info_foot"),
                read_title = $("#read_title"),
                read_foot = $("#read_foot");

            // 隐掉头部
            var no_read_title = dataStorage.getItem(systemConfigPrefix+"no-read-title");
            if (parseInt(no_read_title) == 1) {
                info_title.css(noneCss);
                read_title.css(noneCss);
            } else {
                info_title.css(showCss);
                read_title.css(showCss);
            }

            // 隐掉底部
            var no_foot_title = dataStorage.getItem(systemConfigPrefix+"no-read-foot");
            if (parseInt(no_foot_title) == 1) {
                info_foot.css(noneCss);
                read_foot.css(noneCss);
            } else {
                info_foot.css(showCss);
                read_foot.css(showCss);
            }

        } catch (e) {}
    }

    // 复位txt1
    function resetTxtPage() {
        var iw = pageDir == 'next' ? -window.innerWidth-20 : 0;
        txt[1].css({"-webkit-transform": "translateX("+iw+"px) scale(1)"});
        // 是否要显示过渡效果
        if (showTransform) {
            txt[1].css({"-webkit-transition": "all .3s"});
        }

        // 上一页的时候，当停下来之后，需要将位置进行交换
        if (pageDir == 'prev') {
            setTimeout(function() {
                var read_txt_content = $("#read_txt").html();
                if (read_txt_content) {
                    $("#info_txt").html(read_txt_content);
                }
                hidePrevPageBox();
            }, 380);
        } else {
            setTimeout(function() {
                hidePrevPageBox();
            }, 380);
        }

        // 滑动要复位为false,下次才可以继续
        touchMove = false;
    }
    
    // 复制基本信息用于翻页
    function copyBaseInfo() {
        try {
            $("#read_title").html($("#info_title").html());
            $("#read_progtip").html($("#progtip").html());
            $("#read_book_name").html($("#book_name").html());
            $("#read_chapter_page").html($("#chapter_page").html());
        } catch(e) {}
    }

    // 隐藏上一页
    function hidePrevPageBox() {
        txt[1].css({"display": "none", "-webkit-transform": "translateX(0) scale(1)", "-webkit-transition": "-webkit-transform 0ms"});

        $("#read_title").html("");
        $("#read_progtip").html("");
        $("#read_book_name").html("");
        $("#read_chapter_page").html("");
        $("#read_txt").html("");
    }

    // 提示作品阅读完了
    function showReadEnd() {
        var iw = window.innerWidth;
        var ih = window.innerHeight;

        var doc = document, ul, li;

        var wrapObj = $("#comm_info_readend_wrap");
        var dialogObj = $("#comm_info_readend");

        // 检查对话框是不是已经创建出来过了，因为$方法总是返回一个对象
        if (wrapObj.id && dialogObj.id) return;

        // 背景
        var wrap = doc.createElement("div");
        wrap.css({"position": "absolute", "zIndex": "5555", "visibility": "visible", "backgroundColor": "#908E8F", "opacity": 0.45, "top": 0, "left": 0, "width": iw, "height": ih});
        wrap.attr({"id": "comm_info_readend_wrap"});
        $("body").insertChild(wrap);

        // 显示确认框
        var dialog = doc.createElement("div");
        dialog.setClass("comm_info_readend").attr({"id": "comm_info_readend"});

        // title
        var dialog_title = doc.createElement("div");
        dialog_title.setClass("comm_dialog_title").html('阅读提示');
        dialog.insertChild(dialog_title);

        // 提示
        var dialog_body = doc.createElement("div");
        dialog_body.setClass("info");
        dialog.insertChild(dialog_body);

        ul = doc.createElement("ul");
        dialog_body.insertChild(ul);

        li = doc.createElement("li");
        li.html('<p>当前作品已经阅读完毕，炫色书城还有大量优质作品；欢迎进入书城继续阅读！</p>');
        ul.insertChild(li);

        li = doc.createElement("li");
        li.setClass("btn").html('<span data-id="store" class="btn_color_green">进入书城</span>&nbsp;&nbsp;&nbsp;&nbsp;<span data-id="shelf" class="btn_color_blue2">返回书架</span>');
        ul.insertChild(li);

        $("body").insertChild(dialog);

        dialog.bind(START_EVENT, function(e) {
            e.preventDefault();

            var target = e.target;

            if (target != null) {
                var id = target.attr("data-id");
                if (!id) return false;
 
                if (id == "store") {
                    openStore();
                } else if (id == "shelf") {
                    openShelf();
                }
            }
        });

        dialog.bind(MOVE_EVENT, function(e) { 
            e.preventDefault();
        });
        dialog.bind(END_EVENT, function(e) {
            e.preventDefault();
        });

        // 返回
        wrap.bind(START_EVENT, function(e) {
            e.preventDefault();
            dialog.remove();
            wrap.remove();
        });
    }

})();
