(function() {
    var longTouchTimer = null;
    var myScroll;
    function myScrollLoaded() {
        myScroll = new mScroll("wrapper", {
            hScroll: false,
            bounce: false,
            onBeforeScrollStart: function(e) {
                e.preventDefault();
                
                var target = e.target;

                var bid = target.attr("data-bid");
                var btype = target.attr("data-btype") || "local";
                if (!bid) { 
                    var p = target.$p(".item");
                    if (p) { 
                        bid = p.attr("data-bid");
                        btype = p.attr("data-btype");
                    }
                }

                if (bid && btype) {
                    var that = this;
                    longTouchTimer = setTimeout(function() {
                        longTouchTimer = null;
                        if (that.x == 0 && that.y == 0) {
                            that.disable();
                            if (btype == "down") {
                                showManager(target);
                            } else if (btype == "local") {
                                showManager(target, "local");
                            } else if (btype == "txt") {
                                showManager(target, "txt");
                            }
                        }
                    }, 1500);
                }
            },
            onScrollStart: function(e) {
                longTouchTimer = null;
            }
        });
    }
    
    $(document).bind("touchmove", function (e) { e.preventDefault(); }, false);
    $(document).bind("DOMContentLoaded", function() {        
        myScrollLoaded();

        // 初始化顶部菜单的位置
        var more_menu_option = $("#more_menu_option");

        var iw = window.innerWidth;
        var left = parseInt((iw - parseInt(more_menu_option.css("width"))) / 2);        
        more_menu_option.css({"left": left});

        defaultBookShow();
        downBookShow();
        txtBookShow();

        initUser();
    }, false);
    
    // 下拉菜单
    $("#more_menu").bind(START_EVENT, function(e) {
        e.preventDefault();
        // 显示一个背景层
        var wrap = document.createElement("div");
        wrap.attr({"id": "more_menu_option_wrap"});
        $("body").insertChild(wrap);

        var iw = window.innerWidth,
            ih = window.innerHeight;

        wrap.css({"position": "absolute", "zIndex": "7776", "opacity": 1, "top": 0, "left": 0, "width": iw, "height": ih});

        // 绑定事件
        wrap.bind(START_EVENT, function(e) {
            e.preventDefault();
            hideMoreMenu();
        });

        $("#more_menu_option").toggleClass("show");
    });

    // 点击下拉菜单
    $("#more_menu_option").bind(START_EVENT, function(e) {
        e.preventDefault();

        var target = e.target, data_name = target.attr("data-name");
        if (!data_name) return false;

        if (data_name == "history") {
            openHistory();
        } else if (data_name == "online_shelf") { // 在线书架，要有网络才行
            openOnlineShelf();
        } else if (data_name == "guess") {
            // 为我推荐，需要有网络
            openGuess();
        } else if (data_name == "user_packet") {
            // 进入我的书包
            openUserPacket();  
        } else if (data_name == "local_file") {
            // 进入本地TXT阅读
            openLocalFile();
        } else {
            // 本地书架，隐掉层即可
            hideMoreMenu();
        }
    });
    
    // 主体事件
    $("#main").bind(CLICK_EVENT, function(e) {
        e.preventDefault();
        onTouchEvent(e);
    });

    // 隐藏菜单
    function hideMoreMenu() {
        try {
            $("#more_menu_option_wrap").remove();
            $("#more_menu_option").removeClass("show");
        } catch(e) {}
    }

    // 显示本地下载的作品
    function downBookShow() {
        try {
            var bookindex_data = bookAPI.getBookList();
            if (!bookindex_data) return false;

            bookindex_data = JSON.parse(bookindex_data);
            var books = eval("("+bookindex_data.bookindex+")"), dir = bookindex_data.dir;
            delete bookindex_data;

            fetchHtml(books, "down", dir);            
        } catch (e) {}
    }

    // 显示内置的作品
    function defaultBookShow() {
        // 载入数据
        var url = "book/index.json";
        $.jsonp(url, function(ret) {
            if (ret) {
                fetchHtml(ret, "local");
            }

            myScroll.refresh();
        }, 'index');
    }
    
    // 显示内容
    function fetchHtml(data, btype, dir) {
        var bookshelf_data = $("#bookshelf_data");
        var doc = document, li, img, book;

        // 读取作品信息
        for (var i = 0; i < data.length; i++) {
            book = data[i];
            
            // 显示内置作品的时候，判断一下，如果用户下载过，就不显示内置的信息
            if (btype == 'local') {
                try {
                    // 删除标志，就不显示
                    var is_del = dataStorage.getItem("del.book."+book.bookid);
                    if (is_del) continue;
                    // 下载过就不显示内置的信息，就不显示了
                    var is_exist = bookAPI.existBook(book.bookid);
                    if (is_exist) continue;
                } catch(e) {}
            }
          
            li = doc.createElement("li");
            li.attr({"id": "book_"+book.bookid, "data-bid": book.bookid, "data-btype": btype, "data-bname": book.name, "data-bauthor": book.penname});

            // 封面
            var img_src = 'book/'+book.bookid+'/cover.png';
            if (btype == "down") {
                img_src = dir + '/'+book.bookid+'/cover.png';
            }

            img = doc.createElement("img");
            img.attr({"src": img_src, "data-bid": book.bookid, "data-btype": btype, "data-bname": book.name, "data-bauthor": book.penname});
            img.bind("error", function() {
                img.attr({"src": "img/default_middle_cover.png"});
            });
            li.insertChild(img);

            bookshelf_data.insertBefore(li, bookshelf_store);
        }

        myScroll.refresh();
    }

    // 显示TXT
    function txtBookShow() {
        try {
            var txt_data = fileAPI.bookList();
            if (!txt_data) return false;
            data = JSON.parse(txt_data);

            var bookshelf_data = $("#bookshelf_data");
            var doc = document, li, span, book, bookattr;

            // 读取作品信息
            for (var i = 0; i < data.length; i++) {
                book = data[i];
                
                bookattr = {
                    "id": "txtbook_"+book.id,
                    "data-bid": book.id, 
                    "data-btype": "txt", 
                    "data-bname": book.name,
                    "data-path": book.path,
                    "data-bauthor": "A"
                };
                
                li = doc.createElement("li");
                li.attr(bookattr);
                
                span = doc.createElement("span");
                span.setClass("txt_name").attr(bookattr).html(book.name);
                li.insertChild(span);

                // 封面
                span = doc.createElement("span");
                span.setClass("default_cover_txt").attr(bookattr);
                li.insertChild(span);

                bookshelf_data.insertBefore(li, bookshelf_store);
            }

            myScroll.refresh();
        } catch (e) {}
    }

    // 书架管理，可能要删除作品
    function showManager(target) {
        if (!target) return false;

        var iw = window.innerWidth;
        var ih = window.innerHeight;

        var doc = document, ul, li;

        var wrapObj = $("#comm_book_wrap");
        var dialogObj = $("#comm_book_manager");

        // 检查对话框是不是已经创建出来过了，因为$方法总是返回一个对象
        if (wrapObj.id && dialogObj.id) return;

        // 读取作品信息
        var bid = target.attr("data-bid");
        var bname = target.attr("data-bname");
        var bauthor = target.attr("data-bauthor");
        var btype = target.attr("data-btype");
        if (!bid || !bname || !bauthor) { 
            myScroll.enable();
            return false;
        }

        // 背景
        var wrap = doc.createElement("div");
        wrap.css({"position": "absolute", "zIndex": "5555", "visibility": "visible", "backgroundColor": "#908E8F", "opacity": 0.45, "top": 0, "left": 0, "right": 0, "bottom": 0, "width": "100%", "height": "100%"});
        wrap.attr({"id": "comm_book_wrap"});
        $("body").insertChild(wrap);

        // 显示确认框
        var dialog = doc.createElement("div");
        dialog.setClass("comm_book_manager").attr({"id": "comm_book_manager"});

        // title
        var dialog_title = doc.createElement("div");
        dialog_title.setClass("comm_dialog_title").html('操作确认<span class="close" data-id="close"></span>');
        dialog.insertChild(dialog_title);

        // 提示
        var dialog_body = doc.createElement("div");
        dialog_body.setClass("manager_info");
        dialog.insertChild(dialog_body);

        ul = doc.createElement("ul");
        dialog_body.insertChild(ul);

        li = doc.createElement("li");
        li.html('<p class="title">书名：'+bname+'</p>');
        ul.insertChild(li);
        
        // TXT没有作者
        if (btype != "txt") {
            li = doc.createElement("li");
            li.html('<p>作者：'+bauthor+'</p>');
            ul.insertChild(li);
        }

        // 阅读百分比
        var read_record = '尚未开始';
        var record = Track.getData(bid, "RECORD");
        if (record) {
            read_record = record["percent"];
        }

        li = doc.createElement("li");
        li.html('<p>已阅读：'+read_record+'</p>');
        ul.insertChild(li);

        li = doc.createElement("li");
        li.setClass("btn").html('<span data-id="btn-read" class="btn_color_green">继续阅读</span>&nbsp;&nbsp;&nbsp;&nbsp;<span data-id="btn-del" class="btn_color_red">删除作品</span>');
        ul.insertChild(li);

        // tips
        if (btype == "txt") {
            var tips_html = '<p><img src="img/warning.png"> 仅将TXT从书架移除，不会删除TXT文件。</p>';
        } else {
            var tips_html = '<p><img src="img/warning.png"> 删除作品之后，如果还想再看，重新下载即可。</p>';
            tips_html += '<p><img src="img/warning.png"> 删除之后，会将本地文件一起删除。</p>';
        }

        var dialog_tips = doc.createElement("div");
        dialog_tips.setClass("tips").html(tips_html);
        dialog_body.insertChild(dialog_tips);

        $("body").insertChild(dialog);

        dialog.bind(START_EVENT, function(e) {
            var target = e.target;

            if (target.tagName != 'INPUT') {
                e.preventDefault();
            }

            if (target != null) {
                var id = target.attr("data-id");
                if (!id) return false;
                if (id == "btn-del") {
                    dialog.remove();
                    wrap.remove();

                    setTimeout(function() {
                        showMsg("正在删除中...");
                    }, 100);

                    // 如果是内置作品，只要打标志
                    if (btype == "local") {
                        setTimeout(function() {
                            dataStorage.setItem("del.book."+bid, 1);
                            showMsg("删除完成!");
                            var bookObj = $("#book_"+bid);
                            if (bookObj.id) bookObj.remove();
                            myScroll.refresh();
                        }, 1000);
                    } else if (btype == "txt") { 
                        setTimeout(function() {
                            try {
                                // 删除作品
                                fileAPI.removeBook(parseInt(bid));
                            } catch (e) { 
                                debug(e);
                            }
                            
                            showMsg("删除完成!");
                            var bookObj = $("#txtbook_"+bid);
                            if (bookObj.id) bookObj.remove();
                            myScroll.refresh();
                        }, 1000);
                    } else {                                        
                        setTimeout(function() {
                            try {
                                // 删除作品
                                bookAPI.removeBook(bid);
                                // 删除缓存数据
                                clearStorageData("book.buy."+bid);
                                Track.removeData(bid);

                                dataStorage.removeItem("book.chapter."+bid);
                                dataStorage.removeItem("book.chapter_total."+bid);
                                dataStorage.removeItem("book.mark."+bid);
                                dataStorage.removeItem("book.mark.record."+bid);
                            } catch(e) {}

                            showMsg("删除完成!");
                            var bookObj = $("#book_"+bid);
                            if (bookObj.id) bookObj.remove();
                            myScroll.refresh();
                        }, 1000);
                    }
                } else if (id == "btn-read") {
                    openBook(bid, btype);
                } else if (id == "close") {
                    dialog.remove();
                    wrap.remove();
                }
                myScroll.enable();
            }
        });

        dialog.bind(MOVE_EVENT, function(e) { 
            e.preventDefault();
        });
        dialog.bind(END_EVENT, function(e) {
            e.preventDefault();
            myScroll.enable();
        });

        // 返回
        wrap.bind(START_EVENT, function(e) {
            e.preventDefault();
            dialog.remove();
            wrap.remove();
            myScroll.enable();
        });
    }

    // 初始化用户，如果刚开始连了网，也没有登陆过，就自动产生一个账号登陆
    function initUser() {
        // 判断是否已经登陆
        if (SID()) return;
        
        // 判断是否有网
        if (msxfAPI.onLine() == false) return;
        
        // 进行自动注册一个账号
        var APP_CHANNEL_NAME = msxfAPI.getChannel();
        var url = server() + "/user/initregister?safe="+SAFE_CODE()+'&channel='+APP_CHANNEL_NAME;
        $.jsonp(url, function(ret) {
            if (!ret) return false;
            if (ret.errno != 0) {
                return false;
            }
            if (ret.username) {
                dataStorage.setItem("user.sessid", ret.sessid);
                dataStorage.setItem("user.username", ret.username);
                if (ret.autoreg == 1) {
                    dataStorage.setItem("user.autoreg", 1);
                    // 自动创建的账户
                    //if (ret.password) {
                        // 显示密码给用户；并提示用户修改密码
                        // showInitUserPw(ret.username, ret.password);
                    //}
                } else {
                    dataStorage.removeItem("user.autoreg");
                }
            }

            delete ret;
        }, 'xhr');
    }
    
    // 显示初始化账号密码提示
    function showInitUserPw(username, password) {
        var iw = window.innerWidth;
        var ih = window.innerHeight;

        var doc = document, ul, li;

        var wrapObj = $("#comm_inituserpw_wrap");
        var dialogObj = $("#comm_inituserpw_box");

        // 检查对话框是不是已经创建出来过了，因为$方法总是返回一个对象
        if (wrapObj.id && dialogObj.id) return;

        // 背景
        var wrap = doc.createElement("div");
        wrap.css({"position": "absolute", "zIndex": "5555", "visibility": "visible", "backgroundColor": "#908E8F", "opacity": 0.45, "top": 0, "left": 0, "width": iw, "height": ih});
        wrap.attr({"id": "comm_inituserpw_wrap"});
        $("body").insertChild(wrap);

        // 显示确认框
        var dialog = doc.createElement("div");
        dialog.setClass("comm_book_manager").attr({"id": "comm_inituserpw_box"});

        // title
        var dialog_title = doc.createElement("div");
        dialog_title.setClass("comm_dialog_title").html('系统提示<span class="close" data-id="close"></span>');
        dialog.insertChild(dialog_title);

        // 提示
        var dialog_body = doc.createElement("div");
        dialog_body.setClass("manager_info");
        dialog.insertChild(dialog_body);

        ul = doc.createElement("ul");
        dialog_body.insertChild(ul);

        li = doc.createElement("li");
        li.html('<p>用户名：'+username+'</p>');
        ul.insertChild(li);

        li = doc.createElement("li");
        li.html('<p>密码：'+password+'</p>');
        ul.insertChild(li);

        li = doc.createElement("li");
        li.setClass("btn").attr({"data-id": "btn-passwd"}).html('<div data-id="btn-passwd" class="btn_color_green">更改密码</div>');
        ul.insertChild(li);

        // tips
        var tips_html = '<p>* 初次启动，系统自动注册了一个账号，如需修改密码，进入用户中心设置即可！</p>';
        tips_html += '<p>* 炫色书城可使用陌上香坊的账号直接登陆使用！</p>';

        var dialog_tips = doc.createElement("div");
        dialog_tips.setClass("tips").html(tips_html);
        dialog_body.insertChild(dialog_tips);

        $("body").insertChild(dialog);

        dialog.bind(START_EVENT, function(e) {
            var target = e.target;

            if (target.tagName != 'INPUT') {
                e.preventDefault();
            }

            if (target != null) {
                var id = target.attr("data-id");
                if (!id) return false;
                if (id == "btn-del") {
                    dialog.remove();
                    wrap.remove();
                } else if (id == "close") {
                    dialog.remove();
                    wrap.remove();
                }
                myScroll.enable();
            }
        });

        dialog.bind(MOVE_EVENT, function(e) { 
            e.preventDefault();
        });
        dialog.bind(END_EVENT, function(e) {
            e.preventDefault();
        });

        // 返回
        wrap.bind(START_EVENT, function(e) {
            e.preventDefault();
            dialog.remove();
            wrap.remove();
        });
    }

    // 点击事件
    function onTouchEvent(e) {
        if (!e) return false;
        var target = e.target;

        // 要先判断事件类型
        var bid = target.attr("data-bid");
        var btype = target.attr("data-btype") || "local";
        if (btype == "store") {
            openStore();
            return;
        } else if (btype == "txt") {
            var path = target.attr("data-path");
            var bname = target.attr("data-bname");
            if (!path || !bname) return false;
            // 阅读TXT
            openReadTxt(path, bname, 0);
            return;
        }

        if (!bid) { 
            var p = target.$p(".item");
            if (p) { 
                bid = p.attr("data-bid");
                btype = p.attr("data-btype");
            } else { 
                return false; 
            }
        }

        if (bid) openBook(bid, btype);
    }

})();
